C     Last change:  CDS  10 Jan 2012    5:31 pm
c phasin.for    []
      subroutine phasin()
c get phase records for one earthquake and initialize related arrays
      include 'params.inc'
      parameter (ndly = 11)
      character*1 poldev, pdev, comp
      character*1 isnla, isnlo, jsnla, jsnlo
      character*4 mamaz, mamla, mamor*6, fmit, rshft, dnstrg*5
      character*4 malaz, malla, malor*6
c       poldev specifies device from which p-polarity was obtained
c       pdev specifies device from which p-reading was made -
c            must have same telemetry delay as s-reading, because
c            the same telemetry delay is assumed for both
c       device codes currently used by usgs/uagi are:
c        v,*,1,4 - uags film viewed at 20x
c              v - viewer, geotech or kodak
c              * - assumed to be 20x film
c              1 - one-film digitizer
c              4 - four-film digitizer
c          %,a,f - uagi film viewed at 20x
c              % - assumed to be uagi 20x film
c              a - readings provided to usgs by uagi
c              f - uagi films read by usgs at uagi
c              w - atwc film viewed at 20x
c          d,j,x - daq or dan digital data
c        e,2 - usgs digitized from magnetic tape
c              e - elipse processing
c              2 - cusp processing
c        s - usgs siemens playback from magnetic tape
c        h - usgs helicorder
c        r - uagi helicorder
c        5 - five-day recorder
c        m - sma1 film recorder
c        l - usgs elog
c        b - published bulletin
c        c - unpublished canadian data (eg. tape)
c        t - atwc teletype (corrected for telemetry delay)
c        n - neis (corrected for telemetry delay)
c        p,o,g,k,i,u - pc recorders
c
      character*1 revers
      character seqins*5
      logical eoff, setmast, scatnow
      integer phaind
      real lat,lon,latr,lonr,mag
      character*4 iahead*60, msta*5, msta4*4, nsta*5, icard*110
      integer punt
      common /punt/ punt
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      character*4 ipro, ichec, evtype*1, evstat*1, root*256
      common /dbhip/ ipro, ichec, evtype, evstat, root
      character*1 bksrc
      common /dipu/ ipkdly, igsum, bksrc
      common /dmost/ ipun,ivlr,blank
      common /dph/ noswt, eoff
      common /gmost/ az(npa)
      real*8 time1, time2
      common /hop/ time1,time2,nopu,notim
      common /hpn/ wslope
      logical freor
      common /hopq/ savla,savlo,savez,savor,freor
      common /iclmpq/ lat(nsn),lon(nsn)
      common /imost/ test(100)
      common /ihfgpq/ itest(100)
      common /imost1/ dly(ndly,nsn),iprn,kno,klas(5, nsn)
      common /ilmpu/ ns
      common /ilt/ vthk(2,nsn),ipdly(nsn),mod(nsn),ipthk(nsn)
      common /ilpu/ sw(nsn),ndate(nsn),nhr(nsn),mno(nsn),ielv(nsn)
      common /ilpx/ calr(5, nsn),fmgc(nsn),xmgc(nsn)
      common /ilv/ c(nsn),e(nsn)
      common /iox/ prr(nsn),iuses
      common /logfil/ logfil
      common /in/ irmo,iryr,odmag
      character*1  magke
      common /in1/ magke
      common /int/ thk(lmax+1),lbeg(mmax),lend(mmax),vi(lmax),vsq(lmax),
     *  vsqd(lmmax,lmax),f(lmax,lmmax),kl,ivway,sthk(mmax),sthk1(mmax),
     *  sdly(ndly,nsn)
      integer fmwt, xmwt
      common /ioxl/ fmwt(nsn), xmwt(nsn)
      logical fsteq
      character*1 revp, exdly
      common /ip/ latr,lonr,tpdly(2,nsn),infil,iofil,indexs,
     *  iscod(nsn),ipcod(nsn), fsteq, exdly(4, nsn), revp(6, nsn)
      common /ip1/ rsew(4)
      common /dhip/ inpt,isa,ilis,inmain,injump
      common /olnx/ xmag(npa),fmag(npa),avxm,avfm,xmmed,fmmed
      character*1 kwr, iqdo
      common /pbnoq/ kwr(npa),iqdo(npa)
      common /pmost/ nr,nrp,lbastm,tp(npa),ksmp(npa),kdx(npa)
      character msym*1
      common /pfo/ msym(npa)
      common /pfnoqv/ kdate,khrmn,khr
      common /pgnov/ dt(npa)
      common /pgoq/ s(npa)
      common /pgnoqv/ p(npa),jmin(npa)
      common /pgqv/ w(npa)
      common /ph/ nfirst
      common /phoqn/ inst,knst
      common /pm/ jdx(nsn)
      common /pn/ itpused(npa)
      common /pnl/ ww(npa)
      common /pno/ lph,keyph(npa),nsum
      character phcard*117, krm*2, seq*5
      common /pno1/ phcard(npa), krm(npa), seq
      common /pnoqtx/ ldx(npa)
      character*4 krmp
      common /pnoqv/ krmp(npa)
      character*4 krms
      common /po/ krms(npa)
      common /pot/ ts(npa),ihr,model(npa), keyphi(npa)
      common /povx/ amx(npa)
      common /pox/ fmp(npa),prx(npa),icent1,icent2
      common /pt/ nlay(npa)
      common /pqt/ near
      common /reloc/ irelo, nreloc
      common /qmost/ wt(npa),z
      common /xfmno/ mag
      dimension ws(npa),wws(npa)
      character*1 ifmsm(8)
      character*36 scatph(nsn)
      data ifmsm/'c','d','+','-','d','c','-','+'/
      data scatp/0./, scats/0./, amplif/1.0/, fract/-1./
c      data scatnow/.false./, icent2/0/
      data scatnow/.false./
      if(icent2 .eq. 0) icent2 = itest(55)
      icent1 = icent2
      rewind (16)
      if (iprn .ge. 5) write(punt, '(a)') ' begin phasin'
      kdate = 0
      odmag = -10.
      setmast = .false.
      write(16, 19)
19    format('$beginning of phasin error file')
192   seq = '     '
      magke = ' '
      near = 1
      nfirst = 0
      iskip = 0
      pmin = 9999.
      do i = 1,ns
        jdx(i) = 0
      enddo
      nsktm = 0
      nsum = 0
      ntried = 0
      m = 0
      mm = 1
      mag = blank
      avxm = blank
      avfm = blank
c check value of eoff prior to calling phagt
21    if(eoff) goto 79
      call phagt(phcard, keyph, lph, inpt, injump, eoff, icent2,
     *  itest)
cd    print *, 'phagt read ', lph, ' phase records'
      if(eoff) then
        if(inpt .eq. inmain) then
c         reading from batch input, so end of input job is near
          if(lph .le. 1) then
c this is the end
            write(punt, '(4a)')
            write(logfil, *)
     *      ' completed reading input phase file'
            if(punt .ne. logfil) then
              write(punt, '(4a)')
     *        ' sound bell ', char(7), char(7), char(7)
              write(punt, *)
     *        ' completed reading input phase file'
            endif
            goto 79
          else
c process one more event
            write(logfil, *) 'process one more event'
            if(punt .ne. logfil)
     *      write(punt, *) 'process one more event'
            goto 22
          endif
        else if(inpt .eq. injump) then
c         reading from jump file, so try main batch stream again
          eoff = .false.
          inpt = inmain
          write(logfil, 215)
          if(punt .ne. logfil)
     *    write(punt, 215)
215       format(' jump back to main input stream.')
          if(lph .eq. 1) goto 192
c         process the last jump event
          goto 22
        endif
      endif
22    continue
c
c first:  (mm = 1) - define time based on the 1st phase record
c second: (mm = 2) - try the first rejected time
25    do 27 l = 1, lph
      if( ( (keyph(l) .ge. 0)  .and. (mm .eq. 1) )  .or.
     *    ( (keyph(l) .eq. -4) .and. (mm .eq. 2) ) )then
        msta4 = phcard(l)(1:4)
        msta4 = dnstrg(rshft(msta4))
	comp = dnstrg(phcard(l)(6:6))

c for 4-letter codes, if the last letter is 'e' or 'n' then
c assume this is a horizontal component station!
	if(test(53) .eq. 1.0) then
	  if(msta4(1:1) .ne. ' ') then
	    if((msta4(4:4) .eq. 'n') .or. (msta4(4:4) .eq. 'e')) then
              comp = msta4(4:4)
	    endif
	  endif
	endif

	if((comp .eq. 'e') .or. (comp .eq. 'n')) then
	  msta(1) = msta4//comp
	else
	  msta(1) = msta4//'z'
	endif
c       skip station if not on station list
        if(phaind(msta(1), nsta, ns, i, ierr) .ne. 0) goto 27

	if((scatnow) .and. (scatph(i) .ne. ' ')) then
	  phcard(l)(18:24) = scatph(i)(18:24)
	  phcard(l)(32:36) = scatph(i)(32:36)
	endif

        read(phcard(l), 26, err = 265) jtime, jmin1, p1
26      format(bz, 9x, i8, i2, f5.2)
c define base time in minutes
        lbastm = jmin1
        ktime = jtime
        kdate = ktime/100
        ihr = ktime - kdate*100
	kday = kdate - (kdate/100)*100
c       kbstm = ihr*3600 + jmin1*60 + p1
        kbstm =
     *    (kdate - (kdate/100)*100)*24*3600 + ihr*3600 + jmin1*60 + p1
        khrmn = 100*ihr + jmin1
        goto 28
c decode error
265     keyph(l) = -11
      endif
27    continue
28    m = 0
c
c begin main loop, dealing with each phase record ------------------
      do 78 l = 1, lph
cd    print *, ' '
cd    print *, 'main phasin loop, l = ', l
cd    print *, phcard(l)
c     phcard(l)(105:109) = dnstrg( phcard(l)(105:109) )
      msym(l) = ' '
c key for goto:  keyph   type of record
c                       0 --- phase record
c                      -1 --- comment record
c                      -2 --- summary record
c                      -3 --- instruction record
c                             (begins with more, dist, or 4 blanks)
c                      -4 --- bad time
c                      -5 --- reset record
c                      -6 --- save record - no longer used
c                      -7 --- rerun record - no longer used
c                      -8 --- scatter record
c                      -9 --- not on station list
c                     -10 --- jump record
c                     -11 --- decode error
c                     -12 --- sleep record
c                     -13 --- stop record
c                     -14 --- nongaus record
c		      -15 --- master scatter record
c
      if(keyph(l) .ge. 0) goto 29
c           comm  sum   inst  pha   reset save  rerun scatter
c           not-on jump  decode-er sleep stop nongaus master
      goto (78,   54,   56,   29,   62,   66,   66,   73,
     *      29,    71,   76,       772,  774, 752,    757),
     *        abs(keyph(l))
c
c phase record
29      m = m + 1
        ldx(m) = 0
        keyph(l) = m
        keyphi(m) = l
        ksmp(m) = 1
cd      write(punt, '(a, i5)') 'beginning to process phase record # ', m
c if there is a decimal in 59-62, then this is an old c10 value
c so delete
        do 291 i = 59, 62
          if(phcard(l)(i:i) .eq. '.') then
            phcard(l)(59:62) = '    '
            goto 292
          endif
291     continue
292     msta4 = phcard(l)(1:4)
        msta4 = dnstrg(rshft(msta4))
	comp = dnstrg(phcard(l)(6:6))

c for 4-letter codes, if the last letter is 'e' or 'n' then
c assume this is a horizontal component station!

	if(test(53) .eq. 1.0) then
	  if(msta4(1:1) .ne. ' ') then
	    if((msta4(4:4) .eq. 'n') .or. (msta4(4:4) .eq. 'e')) then
              comp = msta4(4:4)
	    endif
	  endif
	endif

	if((comp .eq. 'n') .or. (comp .eq. 'e')) then
	  msta(m) = msta4//comp
	else
	  msta(m) = msta4//'z'
	endif
c find station in station list
        if(phaind(msta(m), nsta, ns, i, ierr) .ne. 0) then
          iskip = iskip + 1
          if(iskip .gt. 200) then
            write(logfil,83)
            if(punt .ne. logfil) write(punt,83)
            stop 'abort from phasin'
          endif
          write(16, 34) msta(m), phcard(l)
34        format(' ***>',a5, ' is not on station list, so next record ',
     *    ' will not be used:', /, a)
          keyph(l) = -9
          m = m - 1
          goto 78
        endif
c       kdx(phase number) = station number
        kdx(m) = i
	if(setmast) scatph(i) = phcard(l)
        if(setmast) write(punt, '(a, i5, 2a)')
     *  ' station ', i, ' phase set to ', scatph(i)

c
c if this is a scatter run, where all events will have the same
c fixed arrival times but different added errors, change the p and s
c arrival times to the fixed values now.
	if((scatnow) .and. (scatph(i) .ne. ' ')) then
c         assume at this time that the yr mo dy hr of each phase is the same!
	  if(phcard(l)(18:24) .ne. ' ')
     *	   phcard(l)(18:24) = scatph(i)(18:24)
	  if(phcard(l)(32:36) .ne. ' ')
     *	   phcard(l)(32:36) = scatph(i)(32:36)
cd	  write(punt, '(a)') ' reset phase to: ', phcard(l)(1:36)
	endif
	

        read(phcard(l), 30, err = 76 )
     *  krmp(m),jtime,jmin(m),p(m),s(m),
     *  krms(m),amx(m),prx(m),krm(m),dt(m),fmp(m),
     *  poldev, pdev
30      format(bz, 4x, a4, 1x, i8, i2, f5.2, 7x, f5.2, a4, 3x, f4.0,
     *  f3.2, 12x, a2, 1x, f5.2, f5.0, 29x, 2a1)
        if(poldev .eq. ' ') poldev = bksrc
        poldev = dnstrg(poldev)
        if(pdev .eq. ' ') pdev = bksrc
        pdev = dnstrg(pdev)
        if(fmp(m) .le. 0.) fmp(m) = blank
        read(phcard(l), 31, err = 76)
     *        msym(m),ipwc,nlay(m),    iswc
31      format(6x, a1,  i1,     i1, 30x, i1)
cd      print *, 'original ipwc = ', ipwc
c convert msym to lower case
        msym(m) = dnstrg(msym(m))
c fix up amplitude.  if negative, then multiply by -10000
        if(amx(m) .lt. 0.) amx(m) = -amx(m)*10000.
c change first motion symbol to blank for horizontals
c (convention is to use n for north-south component, and e for e-w)
c also, remove magnitude information from horizontals
        if((dnstrg(phcard(l)(6:6)) .eq. 'n') .or.
     *  (dnstrg(phcard(l)(6:6)) .eq. 'e')) then
          fmp(m) = blank
          msym(m) = ' '
          amx(m) = 0.0
        endif

        if((scatp .ne. 0.0) .and. (.not. setmast)) then
          if(phcard(l)(20:24) .ne. '     ') then
c decide if this is the 1 in 10 with 10x greater error!
            fctor = 1.0
            if(ipwc .lt. 4) fctor =  rsew(ipwc+1)
            tail = ran3(0)
            if(tail .le. fract) then
              fctor = fctor*amplif
            endif
            p(m) = p(m) + rnd()*scatp*fctor*fctmagp
            call riorbk(p(m), ipm, fmit, 5, 2)
            write(phcard(l)(20:24), fmit) ipm
          endif
        endif
        if((scats .ne. 0.0) .and. (.not. setmast)) then
          if(phcard(l)(32:36) .ne. '     ') then
            fctor = 1.0
            if(iswc .lt. 4) fctor =  rsew(iswc+1)
            tail = ran3(0)
            if(tail .le. fract) then
              fctor = fctor*amplif
            endif
            s(m) = s(m) + rnd()*scats*fctor*fctmags
            call riorbk(s(m), ism, fmit, 5, 2)
            write(phcard(l)(32:36), fmit) ism
          endif
        endif


c compare time of current station to first station's time
c first compute equivalent of kbstm to see what offset is in seconds
	jhr = jtime - (jtime/100)*100
	jdate = jtime/100
	jday = jdate - (jdate/100)*100
	jbstm =
     *  (jdate - (jdate/100)*100)*24*3600 + jhr*3600 + jmin(m)*60 + p(m)
	if((iabs(jbstm - kbstm) .gt. 600) .or.
     *    (kdate/100 .ne. jdate/100)) then
          write(16, 37) phcard(l)
37        format(' ***> the next phase record has a deviant time',
     *    ', so it will not be used:', /, a)
          keyph(l) = -4
          m = m - 1
          nsktm = nsktm + 1
          if(nsktm .gt. lph/2) then
            if(ntried .eq. 1) goto 78
            seq = '     '
            magke = ' '
            norem = 0
            iskip = 0
            pmin = 9999.
            do 38 iii = 1, ns
              jdx(iii) = 0
38          continue
            nsum = 0
            mm = 2
            write(16, 39) nsktm, lph
39          format(' ***> skipped', i5, ' out of', i5,' records due to',/
     *      ' deviant times, so will try a new base time once')
            nsktm = 0
            ntried = 1
            goto 25
          endif
          goto 78
        endif
c
c adjust jmin(m) for possible difference in day or hour
	jmin(m) = jmin(m) + (jday - kday)*24*60 + (jhr - ihr)*60

c       make sure station record has not expired.
40      ihrmn = 100*jhr + jmin(m)
        call diftim(icent2,jdate,ihrmn,ndate(i),nhr(i),iporm,difhr)
        if(difhr .gt. 0) then
c station has expired
c
cd        write(punt, '(a, 2i10)') ' expired on ', ndate(i), nhr(i)
      call update(indexs, nsta, ielv,
     *         lat, lon, c, e, sw,
     *         klas, calr, xmgc, fmwt, xmwt, fmgc, ipcod, iscod, tpdly,
     *         revp, ndate, nhr, ns,
     *         exdly, icent2, kdate, ihrmn,
     *         infil, iofil)
cd          write(punt,333) indexs,nsta(i),lat(i),lon(i),kdate,ihrmn,
cd   1     sw(i),klas(1, i),calr(1, i),xmgc(i),xmwt(i),fmwt(i),
cd   2     fmgc(i),ipcod(i),iscod(i),tpdly(1,i),(exdly(kk,i),kk=1,4),
cd   2     tpdly(2,i),(revp(kk,i), kk = 1, 6), ndate(i),
cd   3     nhr(i),ielv(i),mod(i),ipthk(i),vthk(1,i),vthk(2,i),
cd   4     ipdly(i),dly(1,i),dly(2,i),dly(3,i),dly(4,i),dly(5,i),
cd   5     sdly(1,i),sdly(2,i),sdly(3,i),sdly(4,i),sdly(5,i),
cd   6     c(i),e(i),prr(i)
cd333      format(       1x,i3,     a4,        2f10.2,       2i10,/
cd   1     1x,f5.2,        i5,                   2f10.2, 2i5/
cd   2     1x,f10.2,            2i10,      f6.2,                  4a1,
cd   2         f6.2, /, 1x,               6a1,      i10,/
cd   3                             1x,4i10,              2f10.2,/
cd   4       1x,i10,                                     5f10.2,/
cd   5     1x,                                        5f10.2,/
cd   6     1x, 3f10.2/)
        endif
c*******
c for purposes of telemetry delay, some sources are equivalent
c (the same reduction is done on reading the station list)
c reduce all sources equivalent to usgs develocorder to 'v'
        if(pdev .eq. '*' .or. pdev .eq. '1' .or. pdev .eq. '4')
     *  pdev = 'v'
c reduce all sources equivalent to uagi develocorder to 'f'
        if ( pdev .eq. '%' .or. pdev .eq. 'a' ) pdev = 'f'
c reduce all sources equivalent to usgs mag tape to 's'
        if (pdev .eq. 'e' .or. pdev .eq. '2') pdev = 's'
c reduce all sources equivalent to uagi daq/dan or pc's to 'd'
c       if (pdev .eq. 'j' .or. pdev .eq. 'x'
c do not include 'p' because yakutat pc is 'p' and has no satellite delay. jcl 6
cc   *  .or. pdev .eq. 'p'
c    *  .or. pdev .eq. 'o' .or. pdev .eq. 'g'
c    *  .or. pdev .eq. 'k' .or. pdev .eq. 'i'
c    *  .or. pdev .eq. 'u') pdev = 'd'
c reduce all sources equivalent to uagi daq/dan 'd'
        if (pdev .eq. 'j' .or. pdev .eq. 'x') pdev = 'd'
c reduce all sources equivalent to uagi pc's to 'g'
        if (pdev .eq. 'o'
     *  .or. pdev .eq. 'k' .or. pdev .eq. 'i'
     *  .or. pdev .eq. 'u') pdev = 'g'
c nhop related code has been removed, now that the station history
c allows more than one telemetry delay (tpdly) per station
c must fix up history to allow for no delay for yakutat pcelog
c         if(phcard(l)(110:110) .ne. ' ') then
c         read(phcard(l)(110:110), '(i1)') nhop
c         tpuse = -nhop*.27
c check the source of the p-phase (pdev) to see if tpdly 1 or 2 should be used
c use second delay if source matches any one of the 4 extra codes
c otherwise use the first delay
        if (pdev .eq. exdly(1, i) .or. pdev .eq. exdly(2, i) .or.
     *      pdev .eq. exdly(3, i) .or. pdev .eq. exdly(4, i)) then
          itpused(m) = 2
          tpuse = tpdly(itpused(m), i)
        else if ((pdev .eq. 't') .or. (pdev .eq. 'n')) then
c         for atwc teletype source "t", set telemetry delay to zero
c         for neis source "n", set telemetry delay to zero
          itpused(m) = 0
          tpuse = 0.0
        else
          itpused(m) = 1
          tpuse = tpdly(itpused(m), i)
        endif
        dt(m) = dt(m) + tpuse
cd        write(punt, '(a)') 'exdly, pdev, itpused(m), tpdly(1,i), tpdly(2,i)'
cd        write(punt, '(4a, 1x, a, i2, 2f6.2)') (exdly(kk, i), kk=1,4),
cd   *    pdev, itpused(m), tpdly(1,i), tpdly(2,i)
c******************************************************************
c take account of polarity reversals
c allow lower case, etc
        if(msym(m) .eq. 'u') msym(m) = 'c'
        if(msym(m) .eq. '.') msym(m) = ' '
        if(msym(m) .eq. 'c' .or. msym(m) .eq. 'd' .or.
     *     msym(m) .eq. '+' .or. msym(m) .eq. '-') then
c reduce all sources equivalent to usgs develocorder to 'v'
          if(poldev .eq. '*' .or. poldev .eq. '1' .or. poldev .eq. '4')
     *      poldev = 'v'
c reduce all sources equivalent to uagi develocorder to 'f'
          if ( poldev .eq. '%' .or. poldev .eq. 'a')
     *      poldev = 'f'
c reduce all sources equivalent to usgs mag tape to 's'
          if (poldev .eq. 'e' .or. poldev .eq. '2'
     *      .or. poldev .eq. 'p' .or. poldev .eq. 'o'
     *      .or. poldev .eq. 'g' .or. poldev .eq. 'k'
     *      .or. poldev .eq. 'i' .or. poldev .eq. 'u')
     *      poldev = 's'
c reduce all sources equivalent to uagi daq/dan
          if (poldev .eq. 'j' .or. poldev .eq. 'x')
     *      poldev = 'd'
          if (poldev .eq. 'v') then
            revers = revp(1, i)
          else if (poldev .eq. 's') then
            revers = revp(2, i)
          else if (poldev .eq. 'w') then
            revers = revp(3, i)
          else if (poldev .eq. 'f') then
            revers = revp(4, i)
          else if (poldev .eq. 'd') then
            revers = revp(5, i)
          else
c any other polarity device (could include ' ' if blank source = ' ')
            revers = revp(6, i)
          endif
c fix first motion symbols if reversed or uncertain
          if      ( revers .eq. 'n' .or. revers .eq. '+') then
c normal or probably normal polarity, so do nothing
          else if ( revers .eq. 'r' .or. revers .eq. '-') then
c reversed or probably reversed polarity, so reverse reading
            do 44 ifm = 1, 4
              if(msym(m) .eq. ifmsm(ifm)) then
                msym(m) = ifmsm(ifm + 4)
                goto 46
              endif
44          continue
46          continue
          else if ( revers .eq. ' ') then
c assume, for now, that blank polarity reversal indicator = probably normal
          else
c unknown is the only possibility left, so do not use reading
            msym(m) = '?'
          endif
        else if (msym(m) .eq. ' ' .or. msym(m) .eq. 'z' .or.
     *           msym(m) .eq. 'n') then
c blank, nodal, or noisy, so do nothing
        else
c any other code, set equal to ?
          write(16, 3) nsta(i), msym(m)
    3     format(/' station ', a4, ' first motion symbol (', a1,
     *    ') is not correct.  Reset to "?"')
          msym(m) = '?'
        endif
c put the corrected first motion into column 65 of the phase record
        phcard(l)(65:65) = msym(m)
        if((msym(m) .eq. 'c') .or. (msym(m) .eq. 'd') .or.
     *     (msym(m) .eq. '+') .or.
     *     (msym(m) .eq. '-')) nfirst = nfirst + 1
c ldx = 0 if there is no s arrival or if the s arrival is
c used in an s-p interval.
        ldx(m) = 0
        jdx(i) = 1
        if(ndate(i) .eq. 99999998) then
c error, station has expired
          write(16, 466) nsta(i), kdate, ihrmn
466       format(' ***> xxxerrorxxx ', a4, ' has expired ',
     *    'and can not be used on ',i6.6,1x,i4)
          keyph(l) = -4
          m = m - 1
          goto 78
        endif
467     tp(m) = 60.*(jmin(m)-lbastm)+p(m)+dt(m)
        kwr(m) = '    '
        iqdo(m) = '    '
c
c fix up weights
c force weight code if ipcod or iscod on station record is not equal 10
c but set ww and wws equal to weights that would have been used
c do not use reading if field is blank
        if(phcard(l)(20:24) .eq. '     ') then
          ipwc = 8
cd       print *, 'ipwc changed to ', ipwc
          phcard(l)(8:8) = '4'
          krmp(m)(4:4) = '4'
        endif
        if(phcard(l)(32:36) .eq. '     ') then
          iswc = 4
        else
c set up s arrival pointer and time
          ldx(m) = 1
          ts(m) = 60.*(jmin(m)-lbastm)+s(m)+dt(m)
        endif
        ww(m) = 0.0
        wws(m) = 0.0
cd     print *, 'station weight sw(i) = ', sw(i)
        if(sw(i) .eq. 0.) then
c in this case, save original weights and ignore ipcod & iscod
c ignore for now case of s-p interval
          if(ipwc .lt. 4) ww(m) = rsew(ipwc+1)**(-2)
          w(m) = 0.
          ipwc = 5
          if(iswc .lt. 4) wws(m) = rsew(iswc+1)**(-2)
          ws(m) = 0.
          iswc = 5
cd       print *, 'w(m), ws(m) = ', w(m), ws(m)
          goto 78
        endif
c
cd     print *, 'p and s replacement codes = ', ipcod(i), iscod(i)
cd     print *, 'ipwc, iswc = ', ipwc, iswc
        if((ipwc .lt. 4) .or. (ipwc .eq. 9)) then
c if the reading was to be used, then check ipcod
          if(ipcod(i) .eq. 10) then
          else if((ipcod(i) .gt. 3) .and. (ipcod(i) .lt. 9)) then
c keep track of original weight for lissum (unless it was 9)
            if(ipwc .ne. 9) ww(m) = rsew(ipwc+1)**(-2)
            ipwc = ipcod(i)
          else if(ipcod(i) .eq. 9) then
            ipwc = 9
          else if(ipcod(i) .lt. 4) then
            ipwc = ipcod(i)
          endif
        endif
        if(iswc .lt. 4) then
c if the reading was to be used, then check iscod
          if(iscod(i) .eq. 10) then
          else if(iscod(i) .gt. 3) then
            wws(m) = test(39) * (rsew(iswc+1)**(-2))
            iswc = iscod(i)
          else if(iscod(i) .lt. 4) then
            iswc = iscod(i)
          endif
        endif
c
        if(ipwc .le. 3) then
c normal p arrival
          w(m) = rsew(ipwc+1)**(-2)
cd	  print *, 'normal p arrival ipwc, w(m) = ', ipwc, w(m)
c find earliest arrival time with w(m) .ne. 0.
          if(tp(m) .lt. pmin) then
            pmin = tp(m)
            near = m
          endif
        else if(ipwc .eq. 9) then
c
c s-p interval
cd       print *, 's-p interval'
          ksmp(m) = 0
c reset ldx, because s is being used in s-p interval
          ldx(m) = 0
          ts(m) = 60.*(jmin(m)-lbastm)+s(m)+dt(m)
c in this case use s weight code for setting weight of s-p interval
c normal s-p case in which there is an s phase arrival
          ws(m) = 0.0
          if(iswc .ge. 4) then
            w(m) = 0.0
          else
            w(m) = test(39) * (rsew(iswc+1)**(-2))
          endif
c do not use negative or zero s-p interval
          if(ts(m) .le. tp(m)) then
            w(m) = 0.0
          endif
          if( (tp(m) .lt. pmin) .and. (w(m) .gt. 0.0) ) then
            pmin = tp(m)
          endif
cd       print *, 's-p interval weight = w(m) = ', w(m)
          goto 78
        else
c
c p arrival with weight code of 4,5,6,7, or 8.
          w(m) = 0.
cd       print *, 'code of 4-8 gives w(m) = ', w(m)
        endif
c
c s arrival (except for s-p case that never reaches here)
        if(iswc .lt. 4) then
          ws(m) = test(39) * (rsew(iswc+1)**(-2))
        else
          ws(m) = 0.
        endif
        goto 78
c
c summary record
54      continue
        nsum = nsum + 1
	write(punt, '(a, i5)') 'nsum = ', nsum
        if(nsum .eq. 1) then
          seq = phcard(l)(92:96)
          evstat = phcard(l)(72:72)
          evtype = phcard(l)(90:90)
c only read date and hrmn if none was found on the phase records
          if(kdate .eq. 0) then
 	    read(phcard(l), '(i6, i4, t35, f2.1)') kdate, khrmn, odmag
	  else
 	    read(phcard(l), '(t35, f2.1)') odmag
	  endif
          magke = dnstrg(phcard(1)(78:78))
        endif
c
c special code for redoubt study - vary errors with magnitude
	if (scatp .lt. 0.0) then
          fctmagp = 0.005 + 0.165*exp(-1.87*odmag)
          fctmags = fctmagp
	  write(punt, '(a, 2f10.3, a, f5.2)')
     *    ' add errors to p & s with standard errors = ',
     *    fctmagp, scats*fctmags, ' for mag = ', odmag
	endif
c end of special section
c
        if((nsum .gt. 1) .or. (igsum .eq. 0)) goto 78
	if(magke .eq. 'k') then
c this is a "fake" summary record, so ignore starting location
	  malor = ' '
	  malla = ' '
	  malaz = ' '
	  goto 78
	endif
        read(phcard(l), 55)
     *  org1,org2,ala1,isnla,ala2,alo1,isnlo,alo2,zres,zres1
55      format(bz,8x,f2.0,f4.2,f2.0,a1,f4.2,f3.0,a1,f4.2,f5.2,
     *    t111, f5.2)
        isnla = dnstrg(isnla)
        isnlo = dnstrg(isnlo)
        malor = phcard(l)(9:14)
        malla = phcard(l)(15:18)
        malaz = phcard(l)(31:34)
 	if(phcard(l)(111:115) .ne. ' ') then
	  malaz = phcard(l)(112:115)
	  zres = zres1
	endif
c	write(punt, '(a, i2, a)') 'phcard(', l, ') is a summary record'
c	write(punt, '(a)') phcard(l)
c	write(punt, '(4a)') 'malor, malla, malaz = ',
c    *    malor, malla, malaz
        goto 78
c
c instruction record
56      read(phcard(l), 57)
     *  ipro,ichec,knst,inst,szres,sla1,jsnla,sla2,slo1,jsnlo,slo2,
     *  srg1,srg2
57      format(2a4,9x,2i1,f5.2,16x,f2.0,a1,f5.2,5x,f3.0,a1,f5.2,11x,
     *  f2.0,f5.2)
        ipro = dnstrg(ipro)
        ichec = dnstrg(ichec)
        jsnla = dnstrg(jsnla)
        jsnlo = dnstrg(jsnlo)
	if(test(38) .eq. 4) then
	  knst = 1
	  inst = 7
	endif
        if (nsum .eq. 0) then
          evstat = phcard(l)(9:9)
          evtype = phcard(l)(10:10)
	  icent2 = itest(55)
        endif
        mamaz = phcard(l)(21:24)
        mamla = phcard(l)(43:46)
        mamor = phcard(l)(74:79)
        seqins = phcard(l)(92:96)
58      if(seq .eq. '     ') seq = seqins
c if the instruction rec is blank and there is a summary record
c     and the summary record was not ignored then use the summary
c     record.  conversely, if the instruction record is not blank or
c     there was no summary record or the summary record was ignored,
c     then use the instruction record.
59      if((mamla .eq. '    ') .and. (nsum .ge. 1) .and.
     *  (igsum .ne. 0)) goto 60
        malla = mamla
        ala1 = sla1
        isnla = jsnla
        ala2 = sla2
        alo1 = slo1
        isnlo = jsnlo
        alo2 = slo2
60      if((mamor .eq. ' ') .and. (nsum .ge. 1) .and.
     *  (igsum .ne. 0)) goto 61
        malor = mamor
        org1 = srg1
        org2 = srg2
61      if((mamaz .eq. '    ') .and. (nsum .ge. 1) .and.
     *  (igsum .ne. 0)) goto 80
        zres = szres
        malaz = mamaz
        goto 80
c
c reset record
62      continue
        if(inpt .eq. injump) then
c error- can not reset from jump file
          write(logfil, 622)
          if(punt .ne. logfil)
     *    write(punt, 622)
622       format(' xxxerrorxxx can not use a reset record in ',
     *    'a jump file')
          stop 'abort from phasin'
        endif
        write(punt, '(1x, a)') phcard(l)
        ipro = dnstrg(phcard(l)(1:4))
        ichec = dnstrg(phcard(l)(5:8))
        nr = lph
        if(nr .eq. 1) goto 90
        write(logfil,65) phcard(l)
        if(punt .ne. logfil)
     *  write(punt,65) phcard(l)
65      format(' ***** logic error at statement 28 of phasin *****',
     *  /,1x,a, /, ' so stop')
        stop 'abort from phasin'
c
c save and rerun
66      write(logfil, 67)
        if(punt .ne. logfil)
     *  write(punt, 67)
67      format(' xxxerrorxxx save and rerun are no longer valid ',
     *  'options.')
        stop 'abort from phasin'
c
c jump record
71      if(l .ne. injump) then
          write(logfil, 712)
          if(punt .ne. logfil)
     *    write(punt, 712)
712       format(' xxxerrorxxx jump record out of place.')
          stop 'abort from phasin'
        endif
        goto 21
c
c scatter record
73      read(phcard(l), 74) scatp, scats
74      format(19x, f5.2, 7x, f5.2)
	if(scatp .ge. 0.) then
	  fctmagp = 1.0
	  fctmags = 1.0
          write(punt,75) scatp,scats
75        format(1x,'scatter: p and s standard errors = ', 2f10.3)
	else
	  scatp = -1.0
          write(punt,'(a, /, a, f10.3)')
     *     ' set p std err = 0.005 + 0.165*exp(-1.87*odmag)',
     *     ' set s std err = (p std err) * ', scats
        endif
        goto 21
c
c nongaus record
752     read(phcard(l), 74) fract, amplif
754     format(19x, f5.2, 7x, f5.2)
        write(punt,75) amplif, fract
756     format(1x,'nongaus: multiply p and s standard errors by ',
     *  f10.3, 1x, f10.3, ' fraction of the time.')
        goto 21
c
c master scatter record
757     setmast = .true.
	scatnow = .false.
	write(punt, '(a)')
     *  ' use this event as a master for random scatter.'
	do 758 i = 1, ns
	  scatph(i) = ' '
758	continue
	goto 21
c
c decode error in phase record
76      write(16, 77) phcard(l)
77      format(' ***> decode error reading this phase record:',/,1x, a)
        if(keyph(l) .ne. -11) then
          keyph(l) = -11
          m = m - 1
          goto 78
        endif
c
c sleep record
772     write(punt, '(1x, a)') phcard(l)
        nr = lph
        ipro = dnstrg(phcard(l)(1:4))
        ichec = dnstrg(phcard(l)(5:8))
        if(nr .eq. 1) goto 90
        write(punt,'(a,/,a)')
     *     ' *** error in phase data input structure ***',
     *     'sleep must be the first record of a new event'
        write(logfil,'(a,/,a)')
     *     ' ** error in phase data input structure **',
     *     'sleep must be the first record of a new event'
        stop 'abort from phasin'
c
c stop record
774     write(punt, '(1x, a)') phcard(l)
        nr = lph
        ipro = dnstrg(phcard(l)(1:4))
        ichec = dnstrg(phcard(l)(5:8))
        if(nr .eq. 1) goto 90
        write(punt,'(a,/,a)')
     *     ' *** error in phase data input structure ***',
     *     'stop must be the first record of a new event'
        write(logfil,'(a,/,a)')
     *     ' ** error in phase data input structure **',
     *     'stop must be the first record of a new event'
        stop 'abort from phasin'
c
78    continue
c
c  end of main loop -------------------------------------------------
c     if m = 0, then terminate program
c
79    nr = m
      if(nr .ge. 1) goto 84
      goto 90
c
80    nr = m
      if((nr .eq. 0) .and. (lph .gt. 1)) goto 90
      if(nr .ge. 1) goto 84
      write(logfil,81) phcard(lph)
      if(punt .ne. logfil)
     *write(punt,81) phcard(lph)
81    format(' xxxx this record skipped - out of place xxxx ',/,a)
      iskip = iskip + 1
      if(iskip .le. 200) then
c write out this event so that the phase file is preserved, for
c whatever that is worth!
        if((ipun .eq. 2) .or. (ipun .eq. 3)) then
          do 815 l = 1, lph
            write(11, '(a)') phcard(l)
815       continue
        endif
        goto 21
      else
82      write(logfil,83)
        if(punt .ne. logfil)
     *  write(punt,83)
83      format(' more than 200 records skipped, so stop')
        stop 'abort from phasin'
      endif
c
84    nrp = nr
      if((itest(38) .eq. 1) .or. (itest(38) .eq. 2)) knst = 1
      if(itest(38) .eq. 3) knst = 0
c define starting savla and savlo
      if(malla .ne. '    ') then
c define starting location from summary record or instruction record
        la = ala1 + .00001
        lo = alo1 + .00001
        call fold2(savla,savlo,la,isnla,ala2,lo,isnlo,alo2)
      else if((abs(test(3))+abs(test(4))) .gt. 0.00001) then
c       define starting location from test(3) and test(4)
        savla = latr
        savlo = lonr
      else
c       define starting location from first 10 p arrival times
c       do this in main routine if savla=savlo=99999.
        savla = 99999.
      endif
c begin definition of starting depth
      savez = 99999.
      if(malaz .ne. '    ') then
        savez = zres + test(8)
      endif

c define starting origin time
      savor = 99999.
      freor = .true.
      if(malor .ne. ' ') then
        savor = 60.*(org1 - lbastm) + org2
        freor = .false.
      else if(inst .eq. 8) then
        inst = 0
      endif
      noswt = 0
      nopwt = 0
      nos = 0
      notim = 0
      otim = 0.0
      do 89 i = 1,nrp
      ji = kdx(i)
      w(i) = w(i)*sw(ji)
      if(w(i) .ne. 0.0) nopwt = nopwt + 1
      if(ldx(i) .ne. 0) then
c   add s data to end of p data matrix
        nos = nos+1
        nrs = nrp+nos
c       ldx(p phase number) = s phase number
        ldx(i) = nrs
        ldx(nrs) = 0
        nlay(nrs) = 0
        tp(nrs) = ts(i)
        ww(nrs) = wws(i)
        if(ws(i) .ne. 0.0) then
          if(ts(i) .lt. tp(i)) then
c           do not use p or s if s time is earlier than p time
	    write(16, '(2a)')
     *       ' ***> do not use p or s because s is earlier than p for ',
     *       nsta(ji)
            wws(i) = 0.
            ws(i) = 0.
            ww(nrs) = 0.
            w(i) = 0.
            ww(i) = 0.
          endif
        endif
        w(nrs) = ws(i)*sw(ji)
        if(w(nrs) .ne. 0.) noswt = noswt + 1
        if((w(i) .ne. 0.) .and. (w(nrs) .ne. 0.)) then
c     calculate origin time from p and s time
          otim = otim + tp(i) - (tp(nrs) - tp(i))/(test(1) - 1.0)
          notim = notim + 1
        endif
        ksmp(nrs) = 1
        dt(nrs) = dt(i)
        jmin(nrs) = jmin(i)
        kdx(nrs) = kdx(i)
        kwr(nrs) = '    '
        iqdo(nrs) = '    '
        msta(nrs) = msta(i)
        p(nrs) = p(i)
        s(nrs) = s(i)
      endif
89    continue
      nr = nrp+nos
      if((notim .ne. 0) .and. (savor .eq. 99999.)) then
        savor = otim/notim
        if(test(38) .lt. 0.0) inst = 8
      endif
c convert inst=7 to inst=9 with origin free - this is
c the option to use for quary blasts with unknown origin time.
      if(inst .eq. 7) then
        inst = 9
        freor = .true.
      endif
90    write(16, '(a)') 'end'
      if(setmast) scatnow = .true.
      return
      end
c end phasin
c prplot.for    []
      subroutine prplot(x, y, xmax, xmin, ymax, ymin, lines, last,
     *      isym, no, most)
c     written by w. gawthrop
c     plot takes a set of x and y values and plots them on the printer
c     arguments
c           x     the array of x coordinates
c           y     the array of y coordinates
c           xmax  the largest value of x
c           xmin  the smallest value of x
c           ymax  the largest value of y
c           ymin  the smallest value of y
c           lines the number of lines for the y axis
c          igraph the matrix used for storage of the entire graph
c                 before printing
c           last  the number of data points
c           isym  the symbol to be used as a point on the graph
c           no,most     this is curve number no of the maximum number
c                       most to be printed on these axes
c
      character*4 isym(last)
      character*1 igraph(111, 56)
      dimension x(last), y(last), zx(12)
      integer punt
      common /punt/ punt
      yl=ymax
      ys=ymin
      xs=xmin
      xl=xmax
      xscale=(xl-xs)/110.
      a=lines-1
      yscale=(yl-ys)/a
      if (no-1)30,10,30
   10 continue
      do 20 i=1,111
      do 20 j=1,lines
   20 igraph(i,j)= ' '
      do 29 i=1,lines
      igraph(1,i)='i'
   29 igraph(111,i)='i'
c------- form s-p for plotting
   30 do 40 i=1,last
c     y(i)=y(i)-x(i)
      xx=x(i)
      yy=y(i)
  303 if (xl-xx) 40,31,31
   31 if (xx-xs)40,32,32
   32 if (yl-yy) 40,33,33
   33 if (yy-ys) 40,34,34
   34 ix=(xx-xs)/xscale+1.5
      iy=(yy-ys)/yscale+.5
      iy=lines-iy
      if (isym(i) .eq. ' ') goto 40
      if (ix.lt.0.or.ix.gt.111) goto 38
      if (iy.lt.0.or.iy.gt.111) goto 38
      igraph(ix,iy)=isym(i)(1:1)
      if (igraph(ix,iy) .eq. ' ') igraph(ix,iy) = '+'
      igraph(ix+1,iy)=isym(i)(2:2)
      igraph(ix+2,iy)=isym(i)(3:3)
      igraph(ix+3,iy)=isym(i)(4:4)
      goto 40
   38 write(punt,39) isym(i)
   39 format(1x,a4,' plots off of graph')
   40 continue
      if (no-most) 50,51,50
   50 return
   51 do 52 k=1,11
   52 zx(k)=10.*      (k-1)*xscale+xs
      zx(12)=zx(11)+10.*xscale
c     write(punt,1)
      write(punt,2)
      yes=yl+yscale
      do 60 i=1,lines
      yes=yes-yscale
   60 write(punt,4) yes,(igraph(j,i),j=1,111 )
      write(punt,6)
      write(punt,7) (zx(k),k=1,12)
    1 format(1h1)
    2 format(1h1, ' ts ',2x,23('i    '))
    4 format(1h ,f6.2,111a1)
    6 format(1h ,6x,22('i....'),'i')
    7 format(1h ,' tp',f6.2,11f10.2)
   80 return
      end
c end prplot
c qdist.for    []
      subroutine qdist(az, deldeg, delta, duse, idclc, kdx, keyd,
     * lat, lon, latep, lonep, ldx, near,
     * ndwt, nprwt, nrp, nrwt, wt)
c if idclc is true, compute distance and azimuth.  in any case sort by
c distance and set weights equal to reading weights.
      include 'params.inc'
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
c     real     az(npa)     azimuth
      real     az(npa)
c     real     deldeg      unused delaz argument
      real     deldeg
c     real     delta(npa)  distance (km)
      real     delta(npa)
c     real     dall(npa)   temporary distance array (all stations)
      real     dall(npa)
c     real     duse(npa)   distance array (stations used)
      real     duse(npa)
c     logical  idclc       if true, the compute new distances, otherwise
c                          just initialize weights and sort by distance.
      logical  idclc
c     integer  kdx(npa)    kdx(phase number) = station number.
      integer  kdx(npa)
c     integer  key(npa)    sort key for used stations
      integer  key(npa)
c     integer  keyd(npa)   sort key for all stations
      integer  keyd(npa)
c     integer  keyuse(npa) key to original phase key
      integer  keyuse(npa)
c     real     lat(nsn)    station latitude
      real     lat(nsn)
c     real     lon(nsn)    station longitude
      real     lon(nsn)
c     real     latep       eq latitude
      real     latep
c     real     lonep       eq longitude
      real     lonep
c     integer  ldx(npa)    0 if no s reading, else array index for s
      integer  ldx(npa)
c     integer  near        key to closest station used
      integer  near
c     integer  ndwt        # stations with p or s used
      integer  ndwt
c     integer  nprwt       # stations with p or s last iteration
      integer  nprwt
c     integer  nrp         # of p and s-p phases
      integer  nrp
c     integer  nrwt        # of phases with weight
      integer  nrwt
c     real     wt(npa)     phase weight
      real     wt(npa)
      parameter (ln=3)
c
      nprwt = nrwt
      ndwt = 0
c initialize distance calculations for current epicenter
c calculate epicentral distances and initialize weights
      do 121 i = 1,nrp
        ji = kdx(i)
c   given station lat & lon (radians) get delta (km) & azimuth (deg)
        if (idclc) then
          call delaz(latep,lonep,delta(i),deldeg,az(i),lat(ji),lon(ji))
        endif
        dall(i) = delta(i)
        if (ldx(i) .gt. 0) then
          k = ldx(i)
          delta(k) = delta(i)
          az(k) = az(i)
        endif
        if(wt(i) .ne. 0.0) then
          ndwt = ndwt + 1
          duse(ndwt) = delta(i)
          keyuse(ndwt) = i
        else if(ldx(i) .gt. 0) then
          if(wt(k) .ne. 0.0) then
            ndwt = ndwt + 1
            duse(ndwt) = delta(i)
            keyuse(ndwt) = i
          endif
        endif
121   continue
c
c sort all stations by distance
      call sort(dall, keyd, nrp)
      near = 1
      if(ndwt .eq. 0) then
        ndwt = 1
        return
      end if
      call sort(duse, key, ndwt)
      near = keyuse(key(1))
      return
      end
c end qdist
c quakes.for    []
      subroutine quakes()
c controls the iteration for one earthquake.
c arrays
c     at(3)        computed shift if hypocenter -- in rotated coordinate sys
c     az(npa)      azimuth measured clockwise from north of station with
c                  ith index as measured from current trial epicenter.
c     azmv(5)      azimuth's divideing quadrants for azimuthly weighted
c                  jeffreys weighting.
c     b(4)         hypocenter shift computed by regres (longitude, latitude,
c                  depth, in kilometers).
c     delta(npa)   distance to station with ith index.
c     dly(ndly, nsn)  p-phase delay for model i at station j.
c     duse(npa)    distance array (km) only for stations to be used.
c     iqdo(npa)    quadrant assignment in jeffreys weighting - printed in output
c                  after distance.
c     itest(100)   integer versions of test variables -- itest(i) = int(test(i)
c     iuse(npa)    if the critical station option is used, then stations to be
c                  used have iuse = 1 whereas all others have iuse = 0.
c     kdx(npa)     kdx(phase index number) = station index number.
c     keyd(npa)    sort index for all stations - ie the first station
c                  has index keyd(1).
c     klas(5, nsn) station response types.
c     ksmp(npa)    0 if the reading is an smp reading, 1 otherwise.
c     kwr(npa)     character*1 variable printed after residual to indicate
c                  something about the reading or weight.
c     lat(nsn)     latitude of station.
c     ldx(npa)     0 if no s reading, else array index position for s phase.
c     lon(nsn)     longitude of station.
c     msta(npa)    character*5 -- station name.
c     nsta(nsn)    character*5 -- station name.
c     se(4)        standard error ellipsoid semimajor axes, lon, lat, z, t.
c     test(100)    reset test values - see manual for definition.
c     tl(3)        ratio of step to standard error.
c     tp(npa)      arrival times.
c     w(npa)       assigned phase weight.
c     wf(51)       jeffreys weighting function weights.
c     wt(npa)      final weight of phase, including such factors as
c                  distance weight.
c     x(4, npa)    partial derivatives of travel time with respect to
c                  longitude, latitude, depth, and origin time.
c     xmean(4)     xmean(i) = average of x(i, j) over j
c     y(4)         final step in longitude, latitude, depth, and origin time,
c                  including effects of any limitions.
c variables
c type name          attributes    use
c
c r*4  aar           comm          average of the absolute value of residuals
c r*4  absgr                       absolute value of largest component of
c                                  hypocenter shift.
c r*4  absy1                       absolute value of y1
c r*4  absy2                       absolute value of y2
c r*4  absy3                       absolute value of y3
c r*4  adjsq         comm          square of vector hypocenter shift
c                                  (y1**2 + y2**2 + y3**2)
c r*4  aveaj         comm          average of the 3 eigenvalues of ss matrix
c r*4  avr           comm          average residual
c r*4  avrps         comm          average residual of all p and s phases but
c                                  excluding s-p residuals
c r*4  avuse         comm          equals avrps unless origin time is fixed
c                                  (inst = 8) in which case it equals zero
c r*4  avwt          comm          average weight
c r*4  azi                         azimuth of change in location when only
c                                  critical stations are used
c r*4  been          comm          in rplain, compute certain constants if
c                                  been = 0. and then set been to 1.  input1
c                                  resets been to 0.
c r*4  blank         comm          blank = 1.e20.  variables set to blank will
c                                  not be printed in the output.
c r*4  damp          comm          damping constant to be used in inversion.
c r*4  del                         distance solution changes when only critical
c                                  stations are used.
c r*4  deldeg                      unused argument of qdist
c r*4  dmax          comm          maximum distance used in distance weighting
c r*4  dz                          depth change when only critical stations
c                                  are used.
c l*4  freor         comm          true only if origin time is not fixed.
c r*4  gap           comm          azimuthal gap in stations
c char iahead        comm          heading for this run
c i*4  iboxc         comm          used in weight to control boxcar weighting
c char icard         comm          dummy input record used in many subs
c i*4  icrit                       equals 0 normally.  equals 1 when only
c                                  critical stations are being used.
c l*4  idclc                       if true, the compute new distances in qdist.
c                                  otherwise just reset reading wts & sort by
c                                  distance.
c i*4  iexit         comm          normally 0 but set to 1 if no solution can
c                                  be computed.
c i*4  iglob         comm          if 0 find global minimum, dup and dwn.
c                                  otherwise just find normal solution.
c i*4  igo           comm          if igo = 1 and test(47) ne 0 then add
c                                  extra equation to fix solution on a plane.
c i*4  incdmp                      incdmp is the number if times in a row
c                                  damping is increased.
c i*4  infor         comm          if not 0 on return from weighting then
c                                  there are not enough readings for a solution.
c i*4  inst          comm          column 19 of instruction record.
c                                  also set = -9 in boxau for calculation of rms
c i*4  logfil        comm          unit number for printed output (equals 6).
c i*4  iph           comm          controls printing heading for step output.
c i*4  iprn          comm          print control variable from print option.
c i*4  ipun          comm          punch control variable from punch option.
c i*4  ivlr          comm          number of the layer with variable thickness.
c i*4  kno           comm          delay model (1-5) being used.
c i*4  knst          comm          column 18 from instruction record.
c i*4  kz            comm          if zero, then compute full inversion.  if
c                                  1, 2, or 3 fix longitude, latitude, or depth.
c                                  if negative, do not add damping equations.
c r*4  latep         comm          geocentric latitude of hypocenter in radians.
c i*4  lbastm        comm          base origin time in minutes.
c r*4  lonep         comm          longitude of hypocenter in radians.
c i*4  ndwt          comm          number of stations with p or s used.
c i*4  near          comm          index number of nearest staton.
c i*4  ni            comm          counter for the number of iterations.
c i*4  nprwt                       # stations with p or s during last iteration.
c i*4  nr            comm          total # of p, s, and s-p phases.
c i*4  nrp           comm          total # of p and s-p phases.
c i*4  nrwt          comm          total # of phases with weight not equal zero.
c i*4  nsmp          comm          total # of s-p phases.
c i*4  nswt          comm          total # of s phases with weight not zero.
c r*4  oldy1                       previous step in longitude (km).
c r*4  oldy2                       previous step in latitude (km).
c r*4  oldy3                       privious step in depth.
c r*4  org           comm          origin time in seconds with respect to lbastm
c r*4  pdrms         comm          predicted rms after next shift in hypocenter.
c r*4  prms                        previous rms value.
c r*4  ratio                       reduction ratio applied to hypocenter shift
c                                  because depth change exceeded test(22).
c r*4  rms           comm          root mean square residual.
c r*4  savez         comm          initial depth.
c r*4  savla         comm          initial latitude.
c r*4  savlo         comm          initial longitude.
c r*4  savor         comm          initial origin time.
c l*4  supout        comm          if true, supress all output.
c r*4  sv30                        saved value of test(30).
c r*4  svla                        saved value of latitude during critical run.
c r*4  svlo                        saved value of longitude during critical run.
c r*4  svz                         saved value of depth during critical run.
c r*4  xadjsq                      square of vector hypocenter shift
c r*4  z             comm          earthquake depth.
c r*4  zdn           comm          maximum downward shift of depth within 1
c                                  standard deviation limit of rms.
c r*4  zer           comm          not used.
c r*4  zup           comm          maximum upward shift of depth within 1
c                                  standard deviation limit of rms.
      include 'params.inc'
      parameter (ndly = 11)
      real lat,lon,latep,lonep
      logical idclc, supout, backup
      character*4 iahead*60, msta*5, nsta*5, icard*110
      integer punt
      common /punt/ punt
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      common /anox/ keyd(npa)
      common /bqz/ avrps,avuse
      common /dhin/ iglob, zup, zdn
      common /dmost/ ipun,ivlr,blank
      common /gmost/ az(npa)
      common /ghnq/ iexit
      logical freor
      common /hopq/ savla,savlo,savez,savor,freor
      common /imost/ test(100)
      common /imost1/ dly(ndly,nsn),iprn,kno,klas(5, nsn)
      common /ihfgpq/ itest(100)
      common /iclmpq/ lat(nsn),lon(nsn)
      common /iiq/ wf(51)
      common /logfil/ logfil
      common /ohq/ gap, supout
      common /oqr/ y(4),kz,at(3),tl(3),pdrms,b(4)
      common /pmost/ nr,nrp,lbastm,tp(npa),ksmp(npa),kdx(npa)
      common /pgqv/ w(npa)
      common /phoqn/ inst,knst
      character*1 kwr, iqdo
      common /pbnoq/ kwr(npa),iqdo(npa)
      common /pnoqtx/ ldx(npa)
      common /qmost/ wt(npa),z
      common /qmost1/ lonep,ni,latep
      common /qgo/ org
      common /qgnotx/ delta(npa)
      common /qn/ zer
      common /qo/ dmax,ndec,adjsq,iph
      common /qw/ azmv(5), iuse(npa), duse(npa), ndwt, iboxc
      logical ddone, adone, tdone, bdone, jdone
      common /qw1/ ddone, adone, tdone, bdone, jdone
      common /rioq/ been,damp,dmpinc,igo
      common /pqt/ near
      common /rfgnoq/ se(4)
      common /rq/ xmean(4),avwt,aveaj
      common /tmost/ x(4,npa)
      common /zmost/ nrwt,rms,nswt,avr,aar,nsmp

c begin code
      if (iprn .ge. 5) write(punt, '(a)') ' begin subroutine quakes'
c -----------------------------------------------------------------------
c initialize various values
c -----------------------------------------------------------------------
      it21 = itest(21)
      backup = .false.
      sv30 = test(30)
      ddone = .false.
      adone = .false.
      tdone = .false.
      bdone = .false.
      jdone = .false.
      incdmp = 0
      idclc = .true.
      icrit = 0
      azmv(1) = 0.0
      do 10 i = 2,5
   10 azmv(i) = azmv(i-1) + 90.
      do 20 i = 1,nr
   20 iuse(i) = 1
      nrwt = 0.0
      avwt = 1.0
      avrps = 0.0
      iexit = 0
      adjsq = 0.
      iph = 0
      prms = 100000.0
      dmpmn = test(35)
      damp = dmpmn
      igo = 1
c -----------------------------------------------------------------------
c use only critical stations unless called from boxaux [inst = -9]
c -----------------------------------------------------------------------
      if ((itest(44) .ge. 100) .and. (inst .ne. -9)) then
        icrit = 1
        if (nrp .le. 6) then
          write(punt, '(a)') ' too few phases to rerun with '
          write(punt, '(a)') '  only critical phases'
          iexit = 2
          return
        endif
        ni = itest(37)
        if(iprn .ge. 5) write(punt, '(a)') ' call subroutine critic'
        call critic(delta,az,w,iuse,nrp,nr,ldx)
c reset weights to reading weights
        do 22 i = 1,nrp
          wt(i) = w(i)*iuse(i)
          kwr(i) = ' '
          if (iuse(i) .eq. 0) kwr(i) = 'x'
          if (ldx(i) .gt. 0) then
            k = ldx(i)
            kwr(k) = ' '
            wt(k) = w(k)*iuse(k)
            if (iuse(k) .eq. 0) kwr(k) = 'x'
            if ( (knst.ne.1) .and. (knst.ne.6) ) wt(k) = 0.
          endif
22      continue
        svz = z
        svla = latep
        svlo = lonep
        if(inst .ne. 9) then
          if (z .lt. 10.) z = 10.
        endif
        call qdist(az, deldeg, delta, duse, .true., kdx, keyd,
     *  lat, lon, latep, lonep, ldx, near,
     *  ndwt, nprwt, nrp, nrwt, wt)
        call trvdrv()
        call zstats()
        if (nrwt .lt. 3) goto 96
        if (inst .ne. 9) then
          goto 110
        else
c fixed location, so go ahead and compute steps and standard errors
c set damping = 0.0 and kz = 0
          kz = 0
          damp = 0.0
          sv34 = test(34)
          test(34) = -1.0
          call regres()
          test(34) = sv34
          return
        endif
      endif

c -----------------------------------------------------------------------
c initialize trial hypocenter
c -----------------------------------------------------------------------
      ni = 1
      if(iprn .ge. 5) write(punt, '(a)')
     *                  ' set ni=1 and init. hypocenter'
      latep = savla
      lonep = savlo
      z = savez
      org = savor
c -----------------------------------------------------------------------
c set weights to reading weights unless called from boxau
c -----------------------------------------------------------------------
      if(inst .ne. -9) then
        if(iprn .ge. 5) write(punt, '(a)') ' set wts to reading wts'
        do 42 i = 1,nrp
          wt(i) = w(i)*iuse(i)
          kwr(i) = ' '
          if (iuse(i) .eq. 0) kwr(i) = 'x'
          if (ldx(i) .gt. 0) then
            k = ldx(i)
            kwr(k) = ' '
            wt(k) = w(k)*iuse(k)
            if (iuse(k) .eq. 0) kwr(k) = 'x'
            if ( (knst.ne.1) .and. (knst.ne.6) ) wt(k) = 0.
          endif
42      continue
        if (iprn .ge. 5) write(punt, '(a)') ' call zstats()'
        call zstats()
      endif

      if (iprn .ge. 5) write(punt, 99) latep, lonep, z, lbastm
c
c -----------------------------------------------------------------------
c inst = 9 -- fixed solution
c -----------------------------------------------------------------------
      if (iabs(inst) .eq. 9) then
        if(iprn .ge. 5) write(punt, '(a)') ' fixed solution'
        ni = itest(37)
        call qdist(az, deldeg, delta, duse, .true., kdx, keyd,
     *  lat, lon, latep, lonep, ldx, near,
     *  ndwt, nprwt, nrp, nrwt, wt)
        call trvdrv()
c do not call weight if called from boxau.  inst = -9
        if(inst .eq. 9) call weight()
        if (iprn .ge. 5) then
          write(punt, *) ' freor = ', freor
          write(punt, *) ' org 	 = ', org
	  write(punt, *) ' avrps = ', avrps
	endif
        if (freor) then
          org = org + avrps
          do 92 i = 1, nr
            if (ksmp(i) .eq. 1) x(4,i) = x(4,i) - avrps
92        continue
          if (iprn .ge. 5) write(punt, '(a)')
     *    ' call zstats()'
          call zstats()
        endif
c return now if called from boxau
        if(inst .eq. -9) return
c otherwise, go ahead and compute steps and standard errors
c   set dmping = 0.0 and kz = 0
c   prevent scaling by setting test(34) = -1.0
        sv34 = test(34)
        test(34) = -1.0
        kz = 0
        damp = 0.0
        call regres()
        test(34) = sv34
        return
      endif
c
c -----------------------------------------------------------------------
c exit if there is not enough data to calculate a solution
c -----------------------------------------------------------------------
c     if (nr .lt. 3) then
      if (nr .ge. 3) goto 110
        gap = 0.0
96      continue
        write(punt,99) latep,lonep,z,lbastm
99      format(/'        latep       lonep           z  base time',/
     *  ,1x,3f12.6,i10)
        write(punt,97) nr
97      format(' xxxxx insufficient data with weights not equal',
     *  ' to zero to calculate a solution', /,
     *  1x, i5, ' readings'/)
        iexit = 1
        rms = 0.
        call qdist(az, deldeg, delta, duse, .true., kdx, keyd,
     *  lat, lon, latep, lonep, ldx, near,
     *  ndwt, nprwt, nrp, nrwt, wt)
        return
c     endif
c -----------------------------------------------------------------------
c begin main iteration loop for hypocentral determination
c -----------------------------------------------------------------------
  110 continue
      if (iprn .ge. 5) then
        write(punt, '(a)') ' top of quakes loop'
        write(punt, '(a, e15.7, /, a)')
     *  ' damp = ', damp, ' call qdist next'
      endif
        call qdist(az, deldeg, delta, duse, .true., kdx, keyd,
     *  lat, lon, latep, lonep, ldx, near,
     *  ndwt, nprwt, nrp, nrwt, wt)
c calculate traveltimes and derivatives from hypocenter to station
      if (iprn .ge. 5) write(punt, '(a)')
     *                   ' call trvdrv to compute ttimes'
cd    print *, 'compute travel times'
      call trvdrv()
      if (iprn .ge. 5) write(punt, '(a)')
     *' call weight to compute residuals and rms'
      call weight()
      if (iprn .ge. 5) write(punt, '(a, f20.4, a, f20.4)')
     *' old rms = ', prms, ' new rms = ', rms
      if (nrwt .lt. 3) goto 96
c----
c check if solution is better than previous one
cd    print *, 'check if solution is better'
cd    print '(a, 3i8)', '  ni, nprwt, nrwt ',
cd   *          ni, nprwt, nrwt
cd    print *, '  prms, rms, damp, backup ', prms, rms, damp, backup
      if (backup) goto 170
      if (nrwt .gt. nprwt) then
        incdmp = 0
        goto 170
      endif
      if (rms .le. prms) then
        incdmp = 0
        if ((ni .gt. 1) .and. (damp .gt. dmpmn)) then
          damp = damp/2.
          if (damp .lt. dmpmn) damp = dmpmn
cd        print *, '  **** decreased (possibly) damp to ', damp
        endif
        goto 170
      endif
cd    print *, 'rms gt prms and nrwt le nprwt '
c allow rms to increase if distance or azimuthal weighting just applied
      if ((ni .eq. test(10)) .or. (ni .eq. test(13))) goto 170
c -----------------------------------------------------------------------
c solution rms increased, so reverse last step and increase damping
c -----------------------------------------------------------------------
c allow an extra iteration to reverse last step (up to test(21)*1.3)
      it21 = it21 + 1
      if(it21 .gt. itest(21)*1.3) it21 = itest(21)*1.3
      if (iprn .ge. 5) write(punt, '(a)')
     *' solution rms increased, so increase damping'
      incdmp = incdmp + 1
      if(incdmp .eq. 3) then
        if (iprn .gt. -2) then
          write(punt, 176)
  176     format(' *** experiencing convergence problems, ')
        endif
      endif
      dmpnew = damp + aveaj
      if(dmpnew .gt. damp*100.) dmpnew = damp*100.
      if(dmpnew .lt. damp*10.) dmpnew = damp*10.
      damp = dmpnew
cd    print *, '  **** increased damp to ', damp
      pdrms = 0.0
      do 177 i = 1,3
        b(i) = blank
  177 continue
      y(1) = -y(1)
      y(2) = -y(2)
      y(3) = -y(3)
      y(4) = -y(1)*xmean(1)-y(2)*xmean(2)-y(3)*xmean(3)
      xadjsq = y(1)**2+y(2)**2+y(3)**2
      backup = .true.
      goto 325
c -----------------------------------------------------------------------
c regression analysis of travel time residuals
c -----------------------------------------------------------------------
  170 continue
      if (iprn .ge. 5) write(punt, '(a)')
     *' compute next step with regres'
      prms = rms
      if (inst .eq. 1) goto 250
      if ((nrwt .eq. 3) .and. (nsmp .lt. 3)) goto 250
c free solution
      if (iprn .ge. 5) write(punt, '(a)')
     *' free solution with kz = 0'
      kz = 0
      call regres()
c do not change depth if horizontal change is large
      if (abs(y(1))+abs(y(2)) .lt. test(25)) goto 300
      if (y(1)**2+y(2)**2 .lt. test(25)**2) goto 300
      if (iprn .ge. 5) write(punt, '(a)')
     *' large epicenter change, so call regres with fixed depth'
c fixed depth solution
  250 kz = 3
cd    print *, 'y1, y2 = ', y(1), y(2)
cd    print *, 'large horiz. shift or inst=1,'
cd    print *, 'or too few phases, so fix depth with kz = ', kz
      if (iprn .ge. 5) write(punt, '(a)')
     *' fixed depth solution with kz = 3'
      call regres()
c limit focal depth change
  300 oldy1 = y(1)
      oldy2 = y(2)
      oldy3 = y(3)
      absy3 = abs(y(3))
c if damp > dmpmn reduce y by a factor of 2
c     if (damp .gt. dmpmn) then
c       y(1) = y(1)*.5
c       y(2) = y(2)*.5
c       y(3) = y(3)*.5
c     endif
      if (absy3 .gt. test(22)) then
        ratio = test(22)/absy3
        y(1) = y(1)*ratio
        y(2) = y(2)*ratio
        y(3) = test(22)*sign(1., y(3))
      endif
c limit horizontal adjustment of epicenter
      absy1 = abs(y(1))
      absy2 = abs(y(2))
      if (absy1 .gt. absy2) then
        absgr = absy1
      else
        absgr = absy2
      endif
      if (absgr .gt. test(24)) then
        ratio = test(24)/absgr
        y(1) = y(1)*ratio
        y(2) = y(2)*ratio
        y(3) = y(3)*ratio
      endif
c avoid hypocenter in air
      if ((z+y(3)) .lt. 0.0) then
        y(3) = -z*test(23) + .000001
      endif
c recompute origin time shift
      y(4) = y(4)-(y(3)-oldy3)*xmean(3)-(y(1)-oldy1)*xmean(1)
     * -(y(2)-oldy2)*xmean(2)
      xadjsq = y(1)**2+y(2)**2+y(3)**2
      if (iprn .ge. 5) write(punt, '(a, 4e15.7)')
     *' final y(1), y(2), y(3), y(4) = ', y(1), y(2), y(3), y(4)
      backup = .false.
  325 if (iprn .ge. 1) call output(0)
c terminate iteration if hypocenter adjustment .lt. test(26)
      if (xadjsq .lt. test(26)) then
c if termination occurs before itest(37) iteration,
c set ni = itest(37) and continue
        if (iprn .ge. 5) write(punt, '(a, e10.5, a, e10.5)')
     *   ' adjustment of ', sqrt(xadjsq), ' < sqrt(test(26)) = ',
     *   sqrt(test(26))
        if (ni .ge. itest(37)) goto 500
        ni = itest(37)
        goto 110
      endif
      ni = ni + 1
      if (ni .gt. it21) goto 500
      if (iprn .ge. 5) write(punt, '(a)') 'adjust hypocenter ********'
      call back(y(2), y(1), latep, lonep, latep, lonep)
      z = z + y(3)
      org = org + y(4)
      adjsq = xadjsq
cd    print *, 'ni, prms, rms ', ni, prms, rms
      goto 110
c ---------------------------------------------------------------------
c termination
c ---------------------------------------------------------------------
  500 if (inst .ne. 8) then
c       reset origin time
        org = org + avrps
        do 507 i = 1,nr
          if (ksmp(i) .eq. 1) x(4,i) = x(4,i) - avrps
  507   continue
        if (iprn .ge. 5) write(punt, '(a, e15.7, a, e15.7)')
     *  ' just increased origin time by avrps = ', avrps, ' to ', org
      endif
      if (iprn .ge. 5) write(punt, '(a)')
     *' call zstats'
      call zstats()
c compute error estimates by solving full normal equations
      if (iprn .ge. 5) write(punt, '(a)')
     *  ' compute error est by solving full normal equations'
      damp = 0.0
      sv34 = test(34)
      test(34) = -1.0
      if(inst .eq. 1) then
        kz = 3
      else
        kz = 0
      endif
      call regres()
      damp = dmpmn
      test(34) = sv34
c ---------------------------------------------------------------------
c if this is the first time through (because igo = 1) & test(30) < 0
c continue run without fixing epicenter
c ---------------------------------------------------------------------
      if ((igo .eq. 1) .and. (test(28) .lt. 0.0) .and.
     * (test(30) .lt. 0.0)) then
        if (iprn .ge. 5) write(punt, '(a)')
     *  ' continue run without fixing epicenter'
        igo = 0
c temporarily change test(30) to 0.0 so epicenter will not be fixed
        test(30) = 0.0
        ni = itest(37)
        ndec = 0
        prms = 100000.
        iph = 0
        avrps = 0.0
        goto 110
      endif
      test(30) = sv30
c ---------------------------------------------------------------------
c if this is the first time through (igo = 1) &
c test(28) < 0 & test(47) >0, then
c continue run without fixing on a plane
c ---------------------------------------------------------------------
      if ((igo .eq. 1) .and. (test(28) .lt. 0.0) .and.
     * (test(47) .gt. 0.)) then
        if (iprn .ge. 5) write(punt, '(a)')
     *  ' continue run without fixing on a plane'
        igo = 0
        ni = itest(37)
        ndec = 0
        prms = 100000.
        iph = 0
        avrps = 0.0
        goto 110
      endif
c -----------------------------------------------------------------------
c for critical solution, compare with normal solution
c -----------------------------------------------------------------------
      if (icrit .ne. 0) then
        dz = z - svz
        call delaz(latep,lonep,del,deldeg,azi,svla,svlo)
        azi = azi + 180.
        if (azi .gt. 360.) azi = azi - 360.
        write(punt,2025) del,azi,dz
 2025   format(/,' using only critical stations the solution changes ',
     *  /,' by:   delta   az     z',/,
     *  6x, 3(1x,f5.1),' km'/)
      endif
      return
      end
c end quakes
c ran3.for    []
      real function ran3(idum)
c portable random number generator from press and others, "numerical
c recipes, the art of scientific computing"
      implicit real(m)
      integer idum
      parameter (mbig=4000000.,mseed=1618033.,mz=0.,fac=2.5e-7)
c         parameter (mbig=1000000000,mseed=161803398,mz=0,fac=1.e-9)
      dimension ma(55)
      data iff /0/
      if(idum.lt.0 .or. iff.eq.0)then
        iff=1
        mj=mseed-REAL(iabs(idum))
        mj=mod(mj,mbig)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.mz)mk=mk+mbig
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.mz)ma(i)=ma(i)+mbig
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.mz)mj=mj+mbig
      ma(inext)=mj
      ran3=mj*fac
      return
      end
c end ran3
c rdtmdp.for    []
      subroutine rdtmdp(l, icard, nsta, ielv,
     *         lat, lon, c, e, sw,
     *         klas, calr, xmgc, fmwt, xmwt, fmgc, ipcod, iscod, tpdly,
     *         revp, ndate, nhr,
     *         exdly)
c decode a time dependent station record (icard) for station number l
      include 'params.inc'
      parameter (ndly = 11)
      parameter (pi = 3.14159265)
      parameter (rad = pi/180.)
      parameter (irecsz = 132)
      integer punt
      common /punt/ punt
      common /logfil/ logfil
      real lat,lon
      dimension ielv(nsn),nsta(nsn)
      dimension lat(nsn),lon(nsn)
      dimension c(nsn),e(nsn),sw(nsn),ndate(nsn),nhr(nsn),klas(5, nsn)
      dimension calr(5, nsn),fmgc(nsn),xmgc(nsn),ipcod(nsn),iscod(nsn)
      integer fmwt, xmwt
      dimension fmwt(nsn),xmwt(nsn),tpdly(2,nsn)
      character*1 exdly(4, nsn), revp(6, nsn)
      character icard*(irecsz)
      character*4 nsta*5, rshft, nsta4*4
      character*1 ins, iew, dnstrg

      read(icard, 334) nsta4, sw(l), klas(1, l), calr(1, l),
     * xmgc(l), xmwt(l), fmwt(l), fmgc(l), ipcod(l), iscod(l),
     * ndate(l), nhr(l), tpdly(1, l), exdly(1, l), exdly(2, l),
     * exdly(3, l), exdly(4, l),  tpdly(2, l), revp(1,l),  revp(2,l),
     * revp(3,l),  revp(4,l), revp(5,l), revp(6,l),
     * klas(2, l), calr(2, l), klas(3, l), calr(3, l),
     * klas(4, l), calr(4, l), klas(5, l), calr(5, l)
  334 format(            a4,   1x, f4.2,          i2,    4x,f5.2,
     *    f4.2,      i1, 1x, i1,    f4.2,       i1,       i1,
     *    4x,i8,     i2,        f4.2,         a1,          a1,
     *          a1,          a1,        f4.2,          a1,          a1,
     *          a1,          a1,        a1,     a1,6x,
     *  4(i2, 4x, f5.2, 1x))
      do 445 kk = 1, 4
	  exdly(kk,l) = dnstrg(exdly(kk,l))
c reduce all sources equivalent to usgs develocorder to 'v'
          if ( exdly(kk,l) .eq. '*' .or. exdly(kk,l) .eq. '1' .or.
     *         exdly(kk,l) .eq. '4')
     *         exdly(kk,l) = 'v'
c reduce all sources equivalent to uagi develocorder to 'f'
          if ( exdly(kk,l) .eq. '%' .or. exdly(kk,l) .eq. 'a')
     *         exdly(kk,l) = 'f'
c reduce all sources equivalent to usgs mag tape to 's'
          if ( exdly(kk,l) .eq. 'e' .or. exdly(kk,l) .eq. '2')
     *         exdly(kk,l) = 's'
c reduce all sources equivalent to Dan/Daq or pc's to 'd'
c         if ( exdly(kk,l) .eq. 'j' .or. exdly(kk,l) .eq. 'x'
c do not include 'p' because yakutat pc is 'p' and has no satellite delay. jcl 6
c    *       .or. exdly(kk,l) .eq. 'o'
c    *       .or. exdly(kk,l) .eq. 'g' .or. exdly(kk,l) .eq. 'k'
c    *       .or. exdly(kk,l) .eq. 'i' .or. exdly(kk,l) .eq. 'u')
c    *         exdly(kk,l) = 'd'
c reduce all sources equivalent to uagi daq/dan 'd'
          if (exdly(kk,l) .eq. 'j' .or. exdly(kk,l) .eq. 'x')
     *      exdly(kk,l) = 'd'
c reduce all sources equivalent to uagi pc's to 'g'
          if (exdly(kk,l) .eq. 'o'
     *      .or. exdly(kk,l) .eq. 'k' .or. exdly(kk,l) .eq. 'i'
     *      .or. exdly(kk,l) .eq. 'u') exdly(kk,l) = 'g'

445   continue
      if (icard(119:123) .ne. ' ') then
        read(icard, 335) alat, alon, ielv(l)
  335   format(118x, f5.3, f5.3, i4)
        call unfold2(lat(l),lon(l),llat,ins,dum1,llon,iew,dum2)
        call fold2(lat(l),lon(l),llat,ins,alat,llon,iew,alon)
        call delaz(lat(1),lon(1),delt,deldeg,azz,lat(l),lon(l))
        c(l) = delt*sin(azz*rad)
        e(l) = delt*cos(azz*rad)
      endif
      nsta4 = rshft(nsta4)
      if (nsta4 .ne. nsta(l)(1:4)) then
        write(punt,381) l,nsta(l)(1:4),nsta4
        write(logfil,381) l,nsta(l)(1:4),nsta4
  381   format(///,'  xxxerrorxxx 391 in station list format, so stop',
     *  /, 1x, i5, 'th station ', 2('"', a4, '" '))
        stop 'abort from rdtmdp'
      endif
c fix up default parameters for blank fields on the station record
c station weight
      if (icard(6:9) .eq. '    ') sw(l) = 1.0
c system type
      if (icard(10:11) .eq. '  ') klas(1, l) = 1
c fmag weight
      if (icard(25:25) .eq. ' ') xmwt(l) = 1.
c xmag weight
      if (icard(27:27) .eq. ' ') fmwt(l) = 1.
c fmag coda multiplier
      if (fmgc(l) .eq. 0.) fmgc(l) = 1.
c  pcode weight-code replacement
      if (icard(32:32) .eq. ' ') ipcod(l) = 10
c scode weight-code replacement
      if (icard(33:33) .eq. ' ') iscod(l) = 10
c expiration date
      if (ndate(l) .eq. 0) ndate(l) = 99999999
      if (ndate(l) .eq. 99999999) nhr(l) = 99
c reversal indicators
      do 332 i = 1, 6
        if((revp(i, l) .ne. ' ') .and.
     *     (revp(i, l) .ne. 'n') .and.
     *     (revp(i, l) .ne. 'r') .and.
     *     (revp(i, l) .ne. '+') .and.
     *     (revp(i, l) .ne. '-') .and.
     *     (revp(i, l) .ne. '?')) then
          write(logfil, '(3a, /, a, /, a)')
     *    ' polarity reversal indicator must be n, r, +, -, or ?,',
     *    ' not ', revp(i, l), icard,
     *    ' indicator is being reset to ?'
          revp(i, l) = '?'
        endif
332   continue
      return
      end
c end rdtmdp
c redgap.for    []
      subroutine redgap(iuse,w,wt,kwr,az,keyd,ldx,nrp)
c reweights stations that geduce a gap of more
c than 60 by 30 or more degrees.
      include 'params.inc'
      character*4 iahead*60, msta*5, nsta*5, icard*110
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      dimension key(npa), ldx(npa)
      dimension iuse(npa),w(npa),wt(npa),az(npa)
      character*1 kwr(npa)
      dimension demp(npa), keyd(npa)
      data amingap /30./
      nst = 1
      noaz = 0
c loop through stations, collecting those with data to be used
      do 8 i = 1, nrp
        k = ldx(i)
        if (wt(i) .eq. 0.) then
          if (k .eq. 0) then
            goto 8
          else if (wt(k) .eq. 0.) then
            goto 8
          endif
        endif
c       found a station with either p or s used
        noaz = noaz + 1
        demp(noaz) = az(i)
    8 continue
    4 call sort(demp,key,noaz)
      nj = noaz + 1
      demp(nj) = demp(1) + 360.
c loop through stations in order of distance, considering
c     any that were weighted out due to distance
      do 30 n = nst, nrp
        i = keyd(n)
        k = ldx(i)
c       check if p arrival was weighted out due to distance
        if (kwr(i) .eq. 'd') goto 5
c       check if s arrival was weighted out due to distance
        if ( (k .ne. 0) .and. (kwr(k) .eq. 'd') ) goto 5
        goto 30
c       found a station that was weighted out due to distance
    5   azi = az(i)
        if(azi .lt. demp(1)) azi = azi + 360.
        do 10 j = 2,nj
          if(azi .lt. demp(j)) goto 20
   10   continue
        j = nj
   20   exgap = demp(j) - demp(j-1)
        if(exgap .le. 2*amingap) goto 30
        rdgap = demp(j) - azi
        tgap = azi - demp(j-1)
        if(tgap .lt. rdgap) rdgap = tgap
        if(rdgap .lt. amingap) goto 30
        wt(i) = w(i)*iuse(i)*.5
        if(wt(i) .gt. 0.) kwr(i) = 'g'
   25   if(k .ne. 0) then
          wt(k) = w(k)*iuse(k)*.5
          if(wt(k) .gt. 0.) kwr(k) = 'g'
        endif
        if(kwr(i) .eq. 'g') then
          noaz = noaz + 1
          demp(noaz) = az(i)
          nst = n + 1
          goto 4
        endif
        if(k .ne. 0) then
          if(kwr(k) .eq. 'g') then
            noaz = noaz + 1
            demp(noaz) = az(i)
            nst = n + 1
            goto 4
          endif
        endif
   30 continue
      return
      end
c end redgap
c regres.for    []
      subroutine regres()
c compute geiger adjustments by regression
c    first rotate coordinates so that the cross-correlation
c    matrix is diagonalized.  output includes orientation and
c    size of error ellipse.
      include 'params.inc'
      parameter (ndly = 11)
      character*4 iahead*60, msta*5, nsta*5, icard*110
      integer punt
      common /punt/ punt
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      common /dmost/ ipun,ivlr,blank
      common /imost/ test(100)
      common /imost1/ dly(ndly,nsn),iprn,kno,klas(5, nsn)
      common /oqr/ y(4),kz,at(3),tl(3),pdrms,b(4)
      common /orz/ onf
      common /phoqn/ inst,knst
      common /pmost/ nr,nrp,lbastm,tp(npa),ksmp(npa),kdx(npa)
      common /qgnotx/ delta(npa)
      common /qmost/ wt(npa),z
      common /zqr/ fno
      common /rfgnoq/ se(4)
      common /rbno/ idip(3),iaaz(3),a(3,3)
      common /rioq/ been,damp,dmpinc,igo
      common /ro/ yse,seorg,phi
      common /rob/ v(4,4),noaxp
      common /rq/ xmean(4),avwt,aveaj
      common /tmost/ x(4,npa)
      common /tonxb/ t(npa),fms(npa)
      common /zmost/ nrwt,rms,nswt,avr,aar,nsmp
      dimension r(3),prch(npa),h(3,3),hh(3,3)
      dimension xsum(4),sigma(4),std(4)
      dimension svx3(npa), svx2(npa)
      dimension asm1(6), ev(3,3), eval(3)
      dimension cent(4,4), sscol(4), xm(3)

c test(29) is the default vlaue of standard error used when there
c    are no degrees of freedom.  if test(29) is negative it is always
c    used regardless of the number of degrees of freedom.
c
c nrwt is the total number of readings with weight .gt. zero.
c
c fno is the sum of p, s, and s-p weights.
c     fno may not equal nrwt because the weights are not normalized.
c
c npors is the number of p and s phases.
c
c onf is the sum of p and s wieghts.
c
c kz is the number of the fixed component, if any.
c
c if solution diverged, increase damping. in this case there is no
c   need to recompute the sum of squares matrix.
c
      nrsave = nr
      if(inst .eq. 9) yse = abs(test(29))
      if(test(34) .ne. -1.0) then
c fix epicenter if test(30) is negative and if not final call
c for error ellipsoid (test(34) = -1.0)
        if(test(30) .lt. 0.) then
	  if(test(30) .eq. -13.) then
c in this unadvertised, temporary test option, fix long and z
            do 101 i = 1, nr
              svx2(i) = x(1, i)
              svx3(i) = x(3, i)
              x(1, i) = 0.0
	      x(3, i) = 0.0
101         continue
	  else if(test(30) .eq. -23.) then
c in this unadvertised, temporary test option, fix long and z
            do 102 i = 1, nr
              svx2(i) = x(2, i)
              svx3(i) = x(3, i)
              x(2, i) = 0.0
	      x(3, i) = 0.0
102         continue
          else
            do 11 i = 1, nr
              svx2(i) = x(1, i)
              svx3(i) = x(2, i)
              x(1, i) = 0.0
              x(2, i) = 0.0
11          continue
          endif
        else

c if kz > 0, fix the component specified by kz
          if(kz .gt. 0) then
            do 12 i = 1, nr
              svx3(i) = x(kz, i)
              x(kz, i) = 0.0
12          continue

c if test(47) ne 0, igo = 1, and kz <= 0,
c then add extra equation to fix on plane
          else if((test(47) .ne. 0.) .and. (igo .eq. 1)) then
            nr = nr + 1
            call rplain()
          endif
        endif
      endif
      phi = nrwt

      npors = 0
      do 13 i = 1, nr
        npors = npors + ksmp(i)
13    continue

c reduce deg of freedom by one if origin time will be calculated
      if(npors .ge. 1) phi = phi - 1.
c compute means of p and s data.
      do 14 j = 1, 4
        xsum(j) = 0.0
        xmean(j) = 0.0
        sscol(j) = 0.0
        do 14 k = 1, 4
          v(j, k) = 0.0
14    continue

      if( (npors .ne. 0) .and. (onf .ne. 0.0) .and.
     *  (inst .ne. 8) ) then
        do 15 j = 1, 4
        do 15 i = 1, nr
          xsum(j) = xsum(j) + wt(i)*x(j, i)*ksmp(i)
15      continue
        do 16 j = 1, 4
          xmean(j) = xsum(j)/onf
16      continue
      endif

      if(test(34) .gt. 0) then
c       compute sum of squares of each column, corrected for mean,
c       for purposes of scaling.  skip if test(34) = 0.0 or if on
c       final call to get error ellipsoid (test(34) = -1.0)
        do 18 j = 1, 4
          do 17 i = 1, nr
            sscol(j) = sscol(j) + wt(i)*(x(j, i)-xmean(j)*ksmp(i))*
     *      (x(j, i)-xmean(j)*ksmp(i))
17        continue
          if(sscol(j) .lt. .00000001) sscol(j) = 1.0
18      continue

c       compute inverse of sqrt of sum of products of squares of
c         each column, to be used in scaling.
        do 19 j = 1, 4
          do 19 k = j, 4
            cent(j, k) = 1./(sqrt(sscol(j))*sqrt(sscol(k)))
19      continue
      else
        do 21 j = 1, 4
          sscol(j) = 1.0
          do 20 k = 1, 4
            cent(j, k) = 1.0
20        continue
21      continue
      endif

c compute normal equations: v is corrected for mean and scaled by cent
      do 23 j = 1, 4
      do 23 k = j, 4
        do 22 i = 1, nr
          v(j, k) = v(j, k) +
     *             wt(i)*(x(j, i)-xmean(j)*ksmp(i))*
     *                   (x(k, i)-xmean(k)*ksmp(i))*cent(j, k)
22      continue
        v(k, j) = v(j, k)
23    continue

c output original data, means, std. deviations.
c compute sigma and standard deviations.
      if(iprn .ge. 3) then
        do 24 j = 1, 4
          sigma(j) = sqrt(v(j, j))
          if(phi .gt. 0.0) then
            std(j) = sigma(j)/sqrt(fno)
          else
            std(j) = 0.0
          endif
24      continue

        write(punt, '(a, e15.7)') ' depth = ', z
        write(punt, 25)
25      format(
     *   45x, 'original data', /, '  delta(km)     t(sec)',
     *   '    x(1, i)        x(2, i)        ',
     *   'x(3, i)        x(4, i)          wt(i)      ksmp(i)  name', /)
        do 27 i = 1, nr
          write(punt, 26) delta(i), t(i),
     *      (x(j, i), j = 1, 4), wt(i), ksmp(i), msta(i)
26        format(1x, 2e11.4, 5e15.7, i10, 1x, a5)
27      continue
        write(punt, 28) sscol
28      format(' scale ss=', 13x, 4e15.7)
        write(punt, 29) xmean, onf, sigma, std
29      format('   xmean =', 13x, 5e15.7, /'   sigma =', 13x, 4e15.7, /
     *   ' std dev =', 13x, 4e15.7)
      endif

c find solution to upper left 2x2 by determinates
c  scaled
c      dlons = v(1, 4)*v(2, 2) - v(2, 4)*v(1, 2)
c      dlons = dlons/(v(1, 1)*v(2, 2) - v(1, 2)**2)
c      print *, 'dlons, still scaled, = ', dlons
c      dlons = dlons*sqrt(sscol(4)/sscol(1))
c      print *, '2x2 dlon = ', dlons
c      write(punt, '(a, 2f12.4)') ' 2x2 dlon = ', dlons

c find eigenvalues [diagonal elements of asm1(6)] and eigenvectors
c     [ev(3, 3)] for the upper left 3x3 portion of v(4, 4) [sum of squares]
c	print *, 'v(1,1), (1,2), (1,3) ', v(1,1), v(1,2), v(1,3)
c	print *, 'v(2,1), (2,2), (2,3) ', v(2,1), v(2,2), v(2,3)
c	print *, 'v(3,1), (3,2), (3,3) ', v(3,1), v(3,2), v(3,3)
c	print *, 'v(1,4), v(2,4), v(3,4) ', v(1,4), v(2,4), v(3,4)
30    call eigen1(asm1, 3, 4, 3, ev, eval, v, damp)
      do 31 j = 1, 3
      do 31 i = 1, j
        ni = i + (j*j-j)/2
        a(i, j) = asm1(ni)
        a(j, i) = a(i, j)
31    continue
c	print *, 'a(1,1), (1,2), (1,3) ', a(1,1), a(1,2), a(1,3)
c	print *, 'a(2,1), (2,2), (2,3) ', a(2,1), a(2,2), a(2,3)
c	print *, 'a(3,1), (3,2), (3,3) ', a(3,1), a(3,2), a(3,3)
c transform xmean(k) into principle axis system.
c transform the response vector v(j, 4), j = 1, 3 to r(j)
      do 32 j= 1, 3
        xm(j) = 0.0
        r(j) = 0.0
        do 32 k = 1, 3
          xm(j) = xm(j) + ev(k, j)*xmean(k)
          r(j) = r(j) + ev(k, j)*v(k, 4)
32    continue
c	print *, 'r(1), r(2), r(3) ', r(1), r(2), r(3)

c calculate azmuth and dip of principle directions.
      if(test(34) .eq. -1.0) then
        do 33 j = 1, 3
          if(ev(1, j) .eq. 0.) then
            iaaz(j) = 0
          else
            azq = atan2(-ev(1, j), ev(2, j))*57.29578
            call formf(azq, iaaz(j), 4, 0)
          endif
          d = sqrt(ev(1, j)**2+ev(2, j)**2)
          dpq = atan2(ev(3, j), d)*57.29578
          call formf(dpq, idip(j), 4, 0)
          if(idip(j) .lt. 0.) then
            idip(j) = -idip(j)
            iaaz(j) = iaaz(j) + 180
          endif
          if(iaaz(j) .lt. 0.) then
            iaaz(j) = iaaz(j) + 360.
          endif
33      continue
      endif

c calculate solution vector in transformed coordinates.
      do 34 j = 1, 3
        if(a(j, j) .gt. damp) then
          at(j) = (r(j)/a(j, j))
        else
          at(j) = blank
        endif
34    continue

c calculate final step in original coordinates.
      do 35 j = 1, 3
        b(j) = 0.0
        do 35 k = 1, 3
          if(at(k) .eq. blank) goto 35
          b(j) = b(j) + ev(j, k)*at(k)
35    continue
      do 36 j = 1, 3
        b(j) = b(j)*sqrt(sscol(4)/sscol(j))
36    continue

c calculate origin time correction.
      b(4) = xmean(4) - b(1)*xmean(1)-b(2)*xmean(2)-b(3)*xmean(3)

      do 37 j = 1, 4
        y(j) = b(j)
37    continue

c calculate predicted sum of squares of residuals after move.
c     write(punt, '(a, /, (1x, 4f15.7))') ' cent(i,j) = ', cent
      pss = v(4, 4)/cent(4, 4)
      do 38 j = 1, 3
        phi = phi - 1.
        pss = pss - b(j)*v(j, 4)/cent(j, 4)
38    continue

c calculate predicted rms.
      pdrms = 10.
      if(fno .gt. 0.) pdrms = sqrt(abs(pss/fno))
      if (iprn .ge. 5) write(punt, '(a, /, 4e15.7)')
     *'           damp            pss          pdrms            phi',
     *damp, pss, pdrms, phi

c estimate standard error, yse.
      if(test(29) .lt. 0.0) then
c       always use test(29) for yse if it is negative.
        yse = -test(29)
      else
        if(phi .ge. 1.) then
          yse = sqrt( v(4, 4)*nrwt / (fno*phi) )
          if(yse .lt. test(29)) then
            yse = test(29)
          endif
        else
          yse = test(29)
        endif
      endif

      if (iprn .ge. 5) write(punt, '(a, /, i15, 3e15.7)')
     *'           nrwt            fno            onf            yse',
     *nrwt, fno, onf, yse

c calculate standard errors and ratios of steps to standard error
c at(j) goes into common
      aveaj = 0.0
      do 39 j = 1, 3
        se(j) = 99.0
        if(at(j) .eq. blank) then
          at(j) = 0.0
        else
          se(j) = 1.87*yse/sqrt(a(j, j))
          if(se(j) .gt. 99.0) se(j) = 99.0
        endif
        aveaj = aveaj + a(j, j)
39    continue
      aveaj = aveaj/3.

c calculate se of origin time.  max is 10.
      seorg = 10.
      if ((inst .ne. 8) .and. (onf .gt. 0.0)) then
        vari = 1./onf
        do 40 i = 1, 3
          if(a(i, i) .lt. 0.000001) goto 41
          vari = vari + xm(i)**2/a(i, i)
40      continue
        seorg = yse*sqrt(vari)
        if(seorg .gt. 10.) seorg = 10.
      endif
41    continue

c for expanded output write out eigenvectors (transformation
c    matrix) and transformed equations.
      if(iprn .ge. 5) then
        do 42 i = 1, 3
          do 42 j = 1, 3
            h(i, j)  = 0.0
            hh(i, j) = 0.0
42      continue

        write(punt, 43)
43      format(/, ' normal equations, scaled and corrected for mean')
        do 45 i = 1, 3
          write(punt, 44) (v(i, j), j = 1, 4)
44        format(10x, e15.7, 8hxdlon + , e15.7, 8hxdlat + ,
     *    e15.7, 6hxdz = , e15.7)
45      continue

        write(punt, 49) v(4, 4)
49      format(32x,
     *   ' corrected & scaled sum of sq of residuals = ', e15.7)
        write(punt, 50)
50      format(/, ' transformation matrix, cols are eigenvectors')
        do 52 i = 1, 3
          write(punt, 51) (ev(i, j), j = 1, 3)
51        format (10x, 3e15.7)
52      continue

c transform the normal equation coeficients to hh(3, 3).
        do 53 i = 1, 3
        do 53 j = 1, 3
        do 53 k = 1, 3
          h(i, j) = h(i, j) + v(i, k)*ev(k, j)
53      continue
        do 54 i = 1, 3
        do 54 j = 1, 3
        do 54 k = 1, 3
          hh(i, j) = hh(i, j) + ev(k, i)*h(k, j)
54      continue
        write(punt, 55)
55      format(/, ' transformed coeficients')
        do 57 i = 1, 3
          write(punt, 56) (hh(i, j), j = 1, 3)
56        format(10x, 3e15.7)
57      continue
c for expanded output write out transformed equations.
        write(punt, 58)  (iaaz(j), idip(j), j = 1, 3)
58      format(/15x, ' azmuth and dip of principal directions ',
     *  /, 10x, 3(5x, i5, 1h/, i3))
        write(punt, 59)
59      format(/10x, ' steps in directions of eigenvectors',
     *  '  step      std error              t')
        do 61 i = 1, 3
          write(punt, 60) i, r(i), a(i,i), at(i), se(i)
60        format
     *    (10x, ' step(', i1, ') = ', e15.7, '/', e15.7, ' = ', 3e15.7)
61      continue

c for expanded output calculate predicted change in residual, (prch(i))
c   these are based on the step to be taken.
        write(punt, 62) b
62      format(/8h dlon = , e15.7, 8h dlat = , e15.7, 6h dz = , e15.7,
     *    6h dt = , e15.7)
        write(punt, 63)
63      format('         current        predicted      predicted      ',
     *  'weight     name', /,
     *       '         residual       tt change      new residual   ')
        xsum(1) = 0.0
        do 66 i = 1, nr
          prch(i) = -b(4)*ksmp(i)
          do 64 j = 1, 3
            prch(i) = prch(i) - x(j, i)*b(j)
64        continue
          anewr = x(4, i) + prch(i)
          xsum(1) = xsum(1) + wt(i)*anewr**2
          write(punt, 65) i, x(4,i), prch(i), anewr, wt(i), msta(i)
65        format(1x, i2, 4f15.7, 1x, a5)
66      continue
        write(punt, 67) v(4, 4), pss, xsum(1)
67      format(/,
     *  ' sum of squares:    original       predicted       linear',
     *  /, 16x, 3e15.7)
      endif

      nr = nrsave
      if(test(30) .lt. 0.) then
        if(test(30) .eq. -13.) then
          do 675 i = 1, nr
            x(1, i) = svx2(i)
            x(3, i) = svx3(i)
675       continue
        else if(test(30) .eq. -23.) then
          do 676 i = 1, nr
            x(2, i) = svx2(i)
            x(3, i) = svx3(i)
676       continue
        else
          do 68 i = 1, nr
            x(1, i) = svx2(i)
            x(2, i) = svx3(i)
68        continue
        endif
      else
        if(kz .gt. 0) then
          do 69 i = 1, nr
            x(kz, i) = svx3(i)
69        continue
        endif
      endif

      if(test(34) .eq. -1.0) then
        do 692 j = 1, 4
          y(j) = 0.0
692     continue
      endif

      return
      end
c end regres
c riorbk.for    []
      subroutine riorbk(x, ix, jfmt, n, nsig)
c     converts a real number (x) to an integer (ix) that may be printed
c       with no decimal point and later read with fn.nsig format
c     if x = '    ' then ix is set = '    ', and an a format is output
c     jfmt is the format to use in writing ix
c     n is field length and can be from 1 to 7
c
      integer punt
      common /punt/ punt
      common /logfil/ logfil
      character*4 ifmt(7), jfmt
      data ifmt/'(i1)','(i2)','(i3)','(i4)','(i5)','(i6)','(i7)'/
      if((n .gt. 7) .or. (n .lt. 1)) goto 1000
      if((nsig .gt. n) .or. (nsig .lt. 0)) goto 2000
      ix = x*10.**nsig + sign(0.50001,x)
      imax = 10**n
      if(ix .ge. imax) ix = imax - 1
      if(ix .le. (-imax/10)) ix = -imax/10 + 1
      jfmt = ifmt(n)
      return
 1000 write(punt,1010) n
      write(logfil,1010) n
 1010 format(' *** the format i',i5,' is not allowed, so stop.')
      goto 3000
 2000 write(punt,2010) n,nsig
      write(logfil,2010) n,nsig
 2010 format(' *** the format f',i5,'.',i5,' is not allowed, so stop.')
 3000 continue
      stop
      end
c end riorbk
c rnd.for    []
      function rnd()
c     acm algorithm 267 by m.c.pike
c     ran3 is a random number generator from the book numerical recipes by
c     press and others that gives a random distribution over the
c     interval 0 to 1.
c     this function computes a normal distribution with mean zero and
c     standard deviation 1.0.
      f = ran3(0)
      x1 = sqrt(-2.*alog(f))
      t = 6.2831853072*ran3(0)
      rnd = x1*sin(t)
      return
      end
c end rnd
c rplain.for    []
      subroutine rplain()
c set up one equation to constrain hypocenter to a plane
      save
      include 'params.inc'
      parameter (pi = 3.1415926)
      parameter (rpd = pi/180.)
      character*4 iahead*60, msta*5, nsta*5, icard*110
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      common /imost/ test(100)
      common /oqr/ y(4),kz,at(3),tl(3),pdrms,b(4)
      common /pmost/ nr,nrp,lbastm,tp(npa),ksmp(npa),kdx(npa)
      common /qmost/ wt(npa),z
      common /rioq/ been,damp,dmpinc,igo
      common /tmost/ x(4,npa)
      dimension hh(3)
c
c fix hypocenter on a plane.
      if (been .ne. 1.0) then
        been = 1.0
        az = abs(test(28))
        di = test(30)
        dir = di*rpd
        cir = pi/2.0-dir
        azr = az*rpd
        hh(1) =  cos(cir)*sin(azr)
        hh(2) = -cos(cir)*cos(azr)
        hh(3) =  sin(cir)
      endif
   75 nrm3 = nr
      wt(nrm3) = 1.
      ksmp(nrm3) = 0
      msta(nrm3) = 'fxpl '
      x(1,nrm3) = hh(1)*test(47)
      x(2,nrm3) = hh(2)*test(47)
      x(3,nrm3) = hh(3)*test(47)
      x(4,nrm3) = 0.0
      return
      end
c end rplain
c rshft.for    []
      character*(*) function rshft(array)
c
c  program to right-justify a character variable
c
c  array - a character variable
      character*(*) array
      character*132 temp
c
c  get length of array
c
      n = len(array)
      rshft = array
      if (n .eq. 0) return
c
c  find the position of the first non-blank character from the right
c
      do 10 i = 1, n
        j1 = n -i + 1
        if (array(j1:j1) .ne. ' ') go to 20
   10 continue
c
c  all characters are blank, so return
c
      return
c
c  shift characters to right
c
   20 if (j1 .eq. n) return
      temp(1:j1) = rshft(1:j1)
      rshft(n-j1+1:n) = temp(1:j1)
      rshft(1:n-j1) = ' '
      return
      end
c end rshft
c sinh.for    []
      function sinh(x)
      sinh = (exp(x) - exp(-x))/2.
      return
      end
c end sinh
c sort.for    []
      subroutine sort(x,key,no)
c w.h.k. lee sort
      dimension x(*),key(*)
      if (no .le. 0) return
      do 1 i=1,no
 1       key(i)=i
      mo=no
 2    if (mo-15) 21,21,23
 21   if (mo-1) 29,29,22
 22   mo=2*(mo/4)+1
      goto 24
 23   mo=2*(mo/8)+1
 24   ko=no-mo
      jo=1
 25   i=jo
 26   if (x(i)-x(i+mo)) 28,28,27
 27   temp=x(i)
      x(i)=x(i+mo)
      x(i+mo)=temp
      kemp=key(i)
      key(i)=key(i+mo)
      key(i+mo)=kemp
      i=i-mo
      if (i-1) 28,26,26
 28   jo=jo+1
      if (jo-ko) 25,25,2
 29   return
      end
c end sort
c strtep.for    []
      subroutine strtep(c, e, kdx, fstlat,fstlon, nrp, nmax, vez,
     *                   vla, vlo, savor, tp, vhalf, w, shiftmax)
c gather together the first nmax p-times for use in determining starting locatio
c dimensions of tim, x, and y must increase if nmax>10
      include 'params.inc'
c              c(nsn)       x coordinates of stations wrt first station in list
      real     c(nsn)
c              e(nsn)       y coordinates of stations wrt first station in list
      real     e(nsn)
c              fstlat       latitude of first station in station list
      real     fstlat
c              fstlno       longitude of first station in station list
      real     fstlon
c              kdx(npa)     kdx(phase number) = station number
      integer  kdx(npa)
c              key(npa)     gives order of arrival times
      integer  key(npa)
c              nrp          number of p arrivals
      integer  nrp
c              nmax         maximum number of p arrivals to use
c                           in estimating first trial location
      integer  nmax
c              vez          depth of earthquake
      real     vez
c              vla          latitude of earthquake
      real     vla
c              vlo          longitude of earthquake
      real     vlo
c              savor        origin time - if not 99999., then fix
      real     savor
c              tim(10)      short list of p arrival times
      real     tim(10)
c              tp(npa)      p arrival times
      real     tp(npa)
c              tptmp(npa)   temporary array for tp values
      real     tptmp(npa)
c              vhalf        halfspace velocity
      real     vhalf
c              w(npa)       weight of readings
      real     w(npa)
c              x(10)        x location of staton
      real     x(10)
c              xz           x location of earthquake
      real     xz
c              y(10)        y location of station
      real     y(10)
c              yz           y location of earthquake
      real     yz
c	       shiftmax	    maximum shift of epicenter from closest station
      real     shiftmax
c save initial depth
      vezsave = vez
      do 20 i = 1, nrp
        tptmp(i) = tp(i)
20    continue
c sort tptmp
      call sort(tptmp, key, nrp)
c find the first nmax values
      n = 0
c in case there are not 4 or more p-arrivals and
c in addition there are none with out zero weight, define xz, yz now
      xz = c(kdx(1))
      yz = e(kdx(1))
      do 25 i = 1, nrp
        k = key(i)
        if(w(k) .eq. 0.) goto 25
        n = n + 1
        tim(n) = tp(k)
        x(n) = c(kdx(k))
        y(n) = e(kdx(k))
        if(n .eq. nmax) then
          nuse = nmax
          goto 30
        endif
25    continue
      nuse = n
      if(nuse .lt. 4) then
        if(nuse .ge. 1) then
c         there are not enough p arrivals to compute a starting location,
c         so use the first one with weight not equal to zero.
          xz = x(1)
          yz = y(1)
        endif
        if(savor .eq. 99999.) savor = 0.
cd      print *, 'savor, vhalf = ', savor, vhalf
cd      do 28 i = 1, nuse
cd        print *,  x(i), y(i), i, tim(i), ' 2'
cd28     continue
        goto 50
      endif
30    continue
c
c solve for best halfspace solution, given m p arrival times.  fix origin
c time if savor .ne. 99999.
cd    print *, 'savor, vhalf = ', savor, vhalf
cd    do 40 i = 1, nuse
cd      print *,  x(i), y(i), i, tim(i), ' 1'
cd40   continue
      call halfsp(nuse, tim, savor, vhalf, x, xz, y, yz, vez)

c make sure starting location is within shiftmax km of first station
c if not, put back at location of first station.
      if(sqrt( (x(1) - xz)**2 + (y(1) - yz)**2 ) .gt. shiftmax) then
        xz = x(1)
        yz = y(1)
        vez = vezsave
      endif

c
50    continue
cd    print *, 'computed starting x, y, z, origin time '
cd    ivez = vez + .5
cd    print *,  xz, yz, ivez, savor, ' 3'
c     print *, 'with respect to ', fstlat, fstlon
c
c convert (xz, yz) to (vla, vlo)
      call back(yz, -xz, vla, vlo, fstlat, fstlon)
c     print *, 'starting lat, lon = ', vla, vlo

      return
      end
c end strtep
c sumgap.for    []
      subroutine sumgap (iuse, az, nr, sge72, nge72, w)
c used by critic to compute sum of gaps > 72 deg and the number of
c gaps > 72 deg
      include 'params.inc'
      dimension iuse(npa),az(npa),aztemp(npa),key(npa),w(npa)
      j = 0
      do 100 i = 1,nr
        if ((iuse(i) .eq. 0) .or. (w(i) .le. 0.)) goto 100
        j = j + 1
        aztemp(j) = az(i)
  100 continue
      call sort(aztemp,key,j)
      k = j + 1
      aztemp(k) = aztemp(1) + 360.
      sge72 = 0.
      nge72 = 0
      do 200 i = 1, j
        gap = aztemp(i+1) - aztemp(i)
        if (gap .le. 72) goto 200
        sge72 = sge72 + gap
        nge72 = nge72 + 1
  200 continue
      return
      end
c end sumgap
c tatime.for    []
      subroutine tatime (delta,depth,vo,ak,ah,tat,toa1)
c model:  linearly increasing velocity over a halfspace
c source: within the layer
c path:   direct wave
c   bill gawthrop  (modified by j.c. lahr  3/6/91)
c     vo   v at surface
c     ak   velocity gradient
c     ah   thickness of linear layer (depth to half space)
      if (delta.ge. 0.1) then
        a = (vo/ak)**2
        b = (vo/ak + depth)**2
        xc = (delta*delta + a - b)/(2.*delta)
        r = sqrt(xc*xc + b)
        toa1 = acos(xc/r)
        if ((r - vo/ak).gt.ah.and.toa1.le.1.57) then
          tat = 900000.
          return
        endif
        c = r*r + delta*xc - xc*xc
        tat = alog((c + r*delta)/(c - r*delta))/(2.*ak)
      else
        tat = alog((vo + depth*ak)/(vo))/ak
        toa1 = 3.1415926
      endif
      return
      end
c end tatime
c tbtime.for    []
      subroutine tbtime (delta,depth,vo,ak,ah,vi,tbt,toa2)
c model:  linearly increasing velocity over a halfspace
c source: within the layer
c path:   refracted wave
c   bill gawthrop  (modified by j.c. lahr  3/6/91)
c     vo   v at surface
c     ak   velocity gradient
c     ah   thickness of linear layer (depth to half space)
c     vi   velocity of half space
      character*55 mess(3)
      integer punt
      common /punt/ punt
      common /logfil/ logfil
      a = (depth + vo/ak)**2
      b = (ah + vo/ak)**2
      c = (vo/ak)**2
      r = vi/ak
      r2 = r*r
      if(b .le. r2) then
        xc1 = sqrt(r2 - a)
        xi = xc1 - sqrt(r2 - b)
        xc2 = sqrt(r2 - c)
        x2 = xc2 - xc1 + xi
        if ((delta - xi - x2) .gt. 0.0) then
          d = r2 + xi*xc1 - xc1*xc1
          e = r2 + x2*xc2 - xc2*xc2
          tbt = alog(
     *     (d + r*xi)*(e + r*x2)/((d - r*xi)*(e - r*x2))
     *          )/(2.*ak) + (delta - xi - x2)/vi
          toa2 = acos(xc1/r)
        else
          tbt = 900000.
        endif
      else
        mess(1) =  ' for a linear increase over halfspace model the'
        mess(2) =  ' velocity at the base of the linear model is '
        mess(3) =  ' greater than the half space velocity, so stop.'
        write(punt, '(a, /, a, /, a)') mess
        write(logfil, '(a, /, a, /, a)') mess
        stop 'abort from tbtime'
      endif
      return
      end
c end tbtime
c tdtime.for    []
      subroutine tdtime (delta, depth, vo, ak, ah, vi, tdt, toa1)
c
c model:  linearly increasing velocity over a halfspace
c source: within the halfspace
c path:   direct wave
c bill gawthrop  (modified by j.c. lahr  3/6/91)
c
c   this sub determines the traveltime of a ray from an origin
c   below the moho in constant velocity material passing thru a crust
c   with velocity increasing linearly with depth
c   bill gawthrop
c     xo   delta
c     yo   depth
c     vo   v at surface
c     ak   velocity gradient
c     ah   thickness of linear layer (depth to half space)
c     vi   velocity of half space
c     tdt
c     toa1
      double precision xp, xp2, xp3, a, b, c, d, xt1, xt2, el
      double precision xpold, xt, xr, chx, denom, xpa, xpb
      double precision r2, r
      integer punt
      common /punt/ punt
c     write(punt, *) 'in tdtime: delta, depth, vo, ak, ah, vi'
c     write(punt, *)  delta, depth, vo, ak, ah, vi
      if ((delta .lt. .001) .or. (delta/depth .lt. .001)) then
        tdt = (depth - ah)/vi + alog((vo + ak*ah)/(vo))/ak
        toa1 = 3.1415926
c	write(punt, *) 'tdt, toa1 ', tdt, toa1
        return
      endif
      a = (vi/ak)**2
      b = a - (vo/ak)**2
      c = a - (ah + vo/ak)**2
      d = a*(depth - ah)**2
ctest
      iwrt = 0
      chx = 0.d0
    6 continue
ctest
      xp = .8d0*delta
      do 15 i = 1, 25
        xpold = xp
        xp2 = xp*xp
        xp3 = xp2*xp
        xt1 = dsqrt(d/xp2 + b)
        xt2 = dsqrt(d/xp2 + c)
        xt = xp + xt1 - xt2
        xr = xt - delta
ctest
        if (iwrt .eq. 1) write(punt, 100)
     *    i, delta, depth, xr, xpold, chx,
     *    xp, xt1, xt2, xp3
100     format(i5, 8f13.7, f13.2)
ctest
        if (dabs(xr).lt..0001d0) then
          xc = delta - xt1
          r2 = a + d/xp2
          r = dsqrt(r2)
          ta = r2 - delta*xp + delta*xc + xp*xc - xc*xc
          tb = r*delta - r*xp
          el = dsqrt((xp2 + (depth - ah)**2)*1.d0)
c	  write(punt, *) 'xc, r2, r, ta, tb, el ', xc, r2, r, ta, tb, el
          tdt = alog((ta + tb)/(ta - tb))/(2.*ak) + el/vi
          toa1 = 1.5707963 + acos(xp/el)
c	  write(punt, *) 'tdt toa1 ', tdt, toa1
c
          return
        endif
        denom = xp3*xt1
        if (denom .eq. 0.d0) then
          xp = -1.d0
        else
          xpa = d/(xp3*xt1)
          xpb = d/(xp3*xt2)
          denom = 1.d0 - xpa + xpb
          if (denom .eq. 0.) then
            xp = -1.d0
          else
            chx = xr/(1.d0 - xpa + xpb)
            xp = xp - chx
          endif
        endif
   10   continue
        if (xp .lt. 0.000001) xp = xpold/4.
   15 continue
ctest
      tdt = 900000.
      if(iwrt .eq. 1) return
      write(punt, 200) delta, depth, vo, ak, ah, vi, tdt, toa1,
     * xr, xpold, chx, xp, xt1, xt2, xp3
  200 format(' sub. tdtime convergence problem', /,
     * '         delta           z          vo           ak
     *             ah            vi         tdt         toa1', /,
     * 5x, 8f13.7, /,
     *  '    xr          xpold          chx          ',
     *  ' xp          xt1          xt2          xp3', /, 5x, 7f13.7)
      iwrt = 1
      goto 6
ctest
      end
c end tdtime
c timit.for    [pc]
      subroutine timit(ikey)
c non standard code for finding cpu time on a vax/vms computer
c* (vax
c      if (ikey .eq. 0) then
c        handle = 0
c        it = lib$init_timer(handle)
c      else
c        it = lib$show_timer(handle)
c      endif
c* vax)
c* (pc
c* pc)
c* (unix
c* unix)
      return
      end
c end timit
c trvcon.for    []
      subroutine trvcon(delta, zsv, t, ain, dtdd, dtdh,
     *  lbeg, lend, lbegm1, nlayers,
     *  ivlr, ivl, thk, nlay, ldx, wti, wtk,
     *  tid, did, jref, vsq, vsqd, v, vi, f, vs, vt, msta, stzsv)
c compute travel time and derivatives for model with constant
c    velocity layers
c indecies for this crustal structure, model number imod.  (lbegm1 = lbeg-1)
c
c    interface    index            velocity       thickness
c
c----surface------(lbeg)--------------------------------------(lstm1)---
c                                  v(lbeg)        thk(lbeg)
c
c-----------------(lbeg+1)------------------------------------(lst)-----
c                                    station is in this layer
c                                  v(lbeg+1)=vt   thk(lbeg+1)
c
c-----------------(lbeg+2) = (leqm1)--------------------------(lstp1)---
c                                  v(leqmq)       thk(leqm1)
c
c-----------------(lbeg+3) = (leq)--------------------------------------
c
c    epicenter is in this layer    v(leq)=vs       thk(leq)
c
c-----------------(lbeg+4) = (leqp1)------------------------------------
c                                  v(jj)          thk(jj)
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c-----------------(lend-1) = -------------------------------------------
c
c-top of half space-(lend)----------------------------------------------
c                                  v(lend)        infinite thickness
c
c
      include 'params.inc'
      parameter (pi = 3.14159265)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      dimension jref(lmax)
      character*5 msta
      double precision umax, utemp, div, u1, u2, tkj, tkjsq, det, c1,
     *  c2, a, b, ac4, dmb, u0, vsqu, xtest, dlimit, d0, d1, d2,
     *  ssqu
c     double precision top, bot
      dimension vsq(lmax), vsqu(lmax), vsqd(lmmax, lmax), v(lmax+2)
      dimension vi(lmax), thk(lmax+1)
      dimension tid(lmax, lmmax), did(lmax, lmmax), f(lmax, lmmax)
      dimension didj(lmmax), tidj(lmmax), tr(lmmax), div(lmax)
      integer punt
      common /punt/ punt
      logical flip
      idrt = 0
      tmin = 99999.
      z = zsv
      stz = stzsv
      if(abs(z - stz) .lt. 0.001) then
        stz = z
      endif
c
c decide which is deeper, station or eq
c and if station is deeper, then reverse roles for now so that
c "eq" is always deeper
      if (z .ge. stz) then
        flip = .false.
      else
        flip = .true.
        temp = z
        z = stz
        stz = temp
      endif
cd    print *, 'z = ', z, ', stz = ', stz
c determine which layer contains the hypocenter.
      sum = 0.0
      do 19 leq = lbeg, lend - 1
        sum = sum + thk(leq)
        if (z .le. sum) then
c         the hypocenter is not in the halfspace
c         leq is the layer containing the hypocenter, leqp1 is the one below,
c         and leqm1 is the one above.
          leqp1 = leq + 1
          leqm1 = leq - 1
          leqr = leq - lbegm1
c         tkj is the distance to the boundary above the eq
          tkj = z - sum + thk(leq)
          tkjsq = tkj**2
cd        print *, 'eq is in layer # ', leq, ', ', tkj, ' km below top'
          goto 23
        endif
19    continue
c the hypocenter is in the halfspace
      leq = lend
cd    print *, 'eq is in halfspace, layer ', leq
      leqm1 = leq - 1
      leqr = leq - lbegm1
      tkj = z - sum
      tkjsq = tkj**2
c set weight if this ray was supposed to be refracted
      if (nlay .ne. 0) wti = 0.0
      idrt = 1
c determine which layer contains the station
23    sum = 0.0
      do 24 lst = lbeg, lend - 1
        sum = sum + thk(lst)
        if (stz .le. sum) then
c         the station is not in the halfspace
c         lst is the layer containing the station, lstp1 is the one below,
c         and lstm1 is the one above.
          lstp1 = lst + 1
          lstm1 = lst - 1
          lstr = lst - lbegm1
c         tkjst is the distance to the boundary above the station
          tkjst = stz - sum + thk(lst)
          tkjstsq = tkj**2
cd        print *,
cd   *      'sta is in layer # ', lst, ', ', tkjst, ' km below top'
          goto 25
        endif
24    continue
c the station is in the halfspace
      lst = lend
cd    print *, 'station is in halfspace, layer ', lst
      lstm1 = lst - 1
      lstr = lst - lbegm1
      tkjst = stz - sum
      tkjstsq = tkj**2
      idrt = 1
      if (leq .eq. lst) then
c eq and station in halfspace
        vs = v(leq)
        vt = vs
        goto 43
      endif
c set the velocity at the source to vs and receiver to vt
25    if(flip) then
        vs = v(lst)
        vt = v(leq)
      else
        vs = v(leq)
        vt = v(lst)
      endif
      tjljll = tid(leq, leqr)
      djljll = did(leq, leqr)
c     correct for variable layers
      if ((ivlr .gt. 0) .and. (leq .gt. ivl) .and.
     *    (jref(leq) .ne. 0)) then
        tjljll = tjljll + thk(ivl)*vsqd(leqr, ivl)*vi(leq)
        djljll = djljll + thk(ivl)/vsqd(leqr, ivl)
        if (leq .gt. ivl + 1) then
          tjljll = tjljll + thk(ivl+1)*vsqd(leqr, ivl+1)*vi(leq)
          djljll = djljll + thk(ivl+1)/vsqd(leqr, ivl+1)
        endif
      endif
c     correct for portion of layer above station
      if ((leq .gt. lst) .and. (vsqd(leqr, lst) .ne. 0.0)) then
        tjljll = tjljll - tkjst*vsqd(leqr, lst)*vi(leq)
cd      print *, 'vsqd(leqr, lst), leqr, lst ', vsqd(leqr, lst), leqr,
cd   *    lst
        djljll = djljll - tkjst/vsqd(leqr, lst)
      endif
c     correct for full layers above station
      if(lst .gt. lbeg) then
        do 30 layer = lbeg, lst - 1
          if (vsqd(leqr, layer) .eq. 0.0) goto 30
          tjljll = tjljll - thk(layer)*vsqd(leqr, layer)*vi(leq)
          djljll = djljll - thk(layer)/vsqd(leqr, layer)
30      continue
      endif
      if ((idrt .eq. 1) .or. (delta .lt. .0001)) goto 43
c***************************************************************************
c calculations for refracted waves.
c***************************************************************************
c if this arrival is to be refracted along a certain boundary
c   calculate travel time or set weight = 0 if this refracted wave
c   can not exist.
      if (nlay .ne. 0) then
        k = nlay + 1
c       k at non-refraction boundary
        if (jref(lbeg + nlay) .eq. 0) goto 31
c       k below(?) halfspace or k above hypocenter layer
        if ((k .gt. nlayers) .or. (k .lt. leqr)) goto 31
c       refraction in layer of hypocenter (compute for direct wave)
        if (k .eq. leqr) then
          idrt = 1
          goto 43
        endif
        didj(k) = did(leq, k)-tkj/vsqd(k, leq)
        if (ivlr .gt. 0) then
          if (k .gt. ivlr) didj(k) = didj(k) +
     *      f(ivl, leqr)*thk(ivl)/vsqd(k, ivl)
          if (k .gt. ivlr+1)
     *      didj(k) = didj(k) + f(ivl+1, leqr)*thk(ivl+1)/
     *      vsqd(k, ivl+1)
        endif
        if (didj(k) .gt. delta) goto 31
        kk = nlay + lbegm1 + 1
        tmin = tid(leq, k )-tkj*vsqd(k, leq)*vi(kk) + delta*vi(kk)
        if (ivlr .le. 0) goto 42
        if (k .gt. ivlr)
     *    tmin = tmin+f(ivl, leqr)*thk(ivl)*vsqd(k, ivl)*vi(k+lbegm1)
        if (k .gt. ivlr+1) tmin = tmin + f(ivl+1, leqr)*thk(ivl+1)*
     *    vsqd(k, ivl+1)*vi(k+lbegm1)
        goto 42
c       if not possible, set p & s weights to zero.
31      wti = 0.0
        if (ldx .ne. 0) wtk = 0.0
      endif
c calculate intercept times and critical distances for all possible
c refracted waves.
      do 34 m = leqp1, lend
        mm = m - lbegm1
        tidj(mm) = 0.
        didj(mm) = 0.
        if (jref(m) .eq. 0) goto 34
        tidj(mm) = tid(leq, mm) - tkj*vsqd(mm, leq)*vi(m)
        didj(mm) = did(leq, mm) - tkj/vsqd(mm, leq)
c       correct for portion of layer above station
        tidj(mm) = tidj(mm) - tkjst*vsqd(mm, lst)*vi(m)
        didj(mm) = didj(mm) - tkjst/vsqd(mm, lst)
c       correct for full layers above station
        if(lst .gt. lbeg) then
          do 32 layer = lbeg, lst - 1
            tidj(mm) = tidj(mm) - thk(layer)*vsqd(mm, layer)*vi(m)
            didj(mm) = didj(mm) - thk(layer)/vsqd(mm, layer)
32        continue
        endif
        if ((ivlr .le. 0) .or. (m .le. ivl)) goto 34
        xtemp = f(ivl, leqr)*thk(ivl)
        tidj(mm) = tidj(mm)+xtemp*vsqd(mm, ivl)*vi(m)
        didj(mm) = didj(mm)+xtemp/vsqd(mm, ivl)
        if (m .le. ivl+1) goto 34
        xtemp = f(ivl+1, leqr)*thk(ivl+1)
        tidj(mm) = tidj(mm) + xtemp*vsqd(mm, ivl+1)*vi(m)
        didj(mm) = didj(mm) + xtemp/vsqd(mm, ivl+1)
34    continue
c xovmax is the maximum cross over distance.  at this or greater
c distance, refracted wave must be first.
      xovmax = (tidj(leqr + 1)-tjljll)/(vi(leq)-vi(leqp1))
cd    print *, 'xovmax = ', xovmax
      if (jref(leqp1) .eq. 0 .or. jref(leq) .eq. 0) xovmax = 9999.
c calculate all possible refracted wave travel-times and find least
      do 40 m = leqr + 1, nlayers
        if (delta .lt. didj(m)) goto 40
        if (jref(m+lbegm1) .eq. 0) goto 40
        tr(m) = tidj(m)+delta*vi(m+lbegm1)
        if (tr(m) .ge. tmin) goto 40
        k = m
        kk = k + lbegm1
        tmin = tr(m)
40    continue
cd    print *, 'min refracted tt and layer = ', tmin, k
c     if (delta .ge. xovmax) then
      if (delta .lt. xovmax) goto 43
c refracted wave is fastest
c relabel travel-time and find derivatives
42      t = tmin
cd      print *, 'refracted wave is fastest'
        dtdd = vi(kk)
        if(flip) then
          dtdh = -vsqd(k, lst)*dtdd
          anin = v(lst)*vi(kk)
        else
          dtdh = -vsqd(k, leq)*dtdd
          anin = v(leq)*vi(kk)
        endif
        ain = deg*asin(anin)
        return
c     endif
c*************************************************************************
c calculations for the direct waves
c*************************************************************************
43    if (leq .eq. lst) then
c for hypocenter and station in same layer
cd      print *, 'hypocenter & station in same layer'
        sqt = sqrt((stz - z)**2 + delta**2)
        tdj1 = sqt/v(leq)
        if (tdj1 .ge. tmin) goto 42
        t = tdj1
        if (sqt .lt. .0001) then
c         hypocentral distance (sqt) less than 0.1 meters
          dtdd = vi(leq)
          dtdh = vi(leq)
          ain = 90.
        else
          dtdd = delta*vi(leq)/sqt
          anin = delta/(sqt)
          if(flip) then
c           downgoing
            dtdh = -(z - stz)*vi(leq)/sqt
            ain = deg*asin(anin)
cd          print *, 'downgoing ain = ', ain
          else
c           upgoing
            dtdh = (z - stz)*vi(leq)/sqt
            ain = 180. - deg*asin(anin)
cd          print *, 'upgoing ain = ', ain
          endif
        endif
        return
      endif
c find parameters of direct wave from hypocenter not in station layer.
c invert the funct. delta(u) (where u is the sine of the angle
c    of incidence) by iterating to find u.
c    use the interpolating funct.:
c       d(u) = c/(umax - u) + a*(u - umax) + b
c    to find better values of u0 which satisfy
c    delta(u0) = given distance within some error, say .03 km.
c use a linear interpolating finction for large epicenteral
c    distances to save computing time.
c----
c find umax for this layer and velocity structure.
c (umax is less than 1 for a hypocenter in a low velocity layer)
      if (delta .lt. 0.0001) then
c vertical ray path
cd      print *, 'vertical ray path'
        u0 = 0.0
        ssqu = 1.d0
        umax = 1.0
        vsqu(lst) = (thk(lst)-tkjst)/(v(leq)/v(lst))
        if(lst+1 .le. leqm1) then
          do 52 l = lst + 1, leqm1
            vsqu(l) = thk(l)/(v(leq)/v(l))
52        continue
        endif
        goto 220
      endif
c non-vertical ray path
cd    print *, 'non-vertical ray path'
      umax = v(leq)/v(lst)
      do 54 l = lst, leqm1
        utemp = v(leq)/v(l)
        div(l) = utemp**2
        if (utemp .lt. umax) umax = utemp
54    continue
cd    print *, 'non-vertical ray.  umax = ', umax
      if (umax .gt. 1.d0) umax = 1.d0
c choose 2 initail points (u1, d1) and (u2, d2) for interpolation,
c    depending on epicentral distance.
      u1 = .75d0*umax
      u2 = delta/sqrt((z-stz)**2+delta**2)
      if (u2 .gt. umax-1.d-4) u2 = umax-1.d-4
      if (u2 .gt. u1) goto 56
      utemp = u1
      u1 = u2
      u2 = utemp
56    continue
c first take care of eq layer and station layer:
      d1 = tkj*u1/dsqrt(1.d0-u1**2) +
     *     (thk(lst) - tkjst)*u1/dsqrt(  vsq(leq)/vsq(lst) - u1**2 )
c    *     (thk(lst) - tkjst)*u1/dsqrt( (v(leq)/v(lst))**2 - u1**2 )
      d2 = tkj*u2/dsqrt(1.-u2**2) +
     *     (thk(lst) - tkjst)*u2/dsqrt(  vsq(leq)/vsq(lst) - u2**2 )
c    *     (thk(lst) - tkjst)*u2/dsqrt( (v(leq)/v(lst))**2 - u2**2 )
c then add terms for layers in between:
      if(lst+1 .le. leqm1) then
        do 58 l = lst+1, leqm1
          d1 = d1 + u1*thk(l)/dsqrt(  vsq(leq)/vsq(l) - u1**2 )
c         d1 = d1 + u1*thk(l)/dsqrt( (v(leq)/v(l))**2 - u1**2 )
          d2 = d2 + u2*thk(l)/dsqrt(  vsq(leq)/vsq(l) - u2**2 )
c         d2 = d2 + u2*thk(l)/dsqrt( (v(leq)/v(l))**2 - u2**2 )
58      continue
      endif
c begin the iteration loop.
      do 150 ll = 1, 25
cd      print *, 'u1, d1, u2, d2 ', u1, d1, u2, d2
c now find the constants a, b, c of d(u) subject to the conditions
c       d(u1) = d1, d(u2) = d2, and d(0) = 0
        det = u1*u2*(u2-u1)
        c1 = d1*u2*(umax-u1)
        c2 = d2*u1*(umax-u2)
        a = (c1-c2)/det
        b = (c1*(2.d0*umax-u2)-c2*(2.d0*umax-u1))/det
        ac4 = 4.d0*a*(a*umax**2-b*umax)
        dmb = delta - b
c invert d(u0) for u0 and find d0 = delta(u0)
        u0 = umax+(dmb-dsqrt(dmb**2+ac4))/(2.d0*a)
        ssqu = dsqrt(1. - u0**2)
        if (u0 .ge. .99999d0) then
c if wave leaves hypocenter nearly horizontally (ie u goes to 1)
c    then compute tdir as wave travelling along top of layer leq
cd        print *, 'compute tdir as wave along top of eq layer'
          tdir = tjljll + delta*vi(leq)
          if (tdir .lt. tmin) then
c           travel time derivatives for hypocenter at top of a layer
            t = tdir
            if(flip) then
c             downgoing
              anin = v(lst)*vi(leq)
              ain =  deg*asin(anin)
              dtdh = -sqrt(1. - anin**2)*vi(lst)
              dtdd = vi(leq)
            else
c             upgoing
              ain = 90.
              dtdh = 0.0
              dtdd = vi(leq)
            endif
            return
          endif
          goto 42
        endif
        if (u0 .ge. umax-1.d-6) then
          u0 = umax-1.d-6
          ssqu = dsqrt(1. - u0**2)
        endif
        d0 = tkj*u0/ssqu
        vsqu(lst) = (thk(lst) - tkjst)/dsqrt( vsq(leq)/vsq(lst)-u0**2)
c       vsqu(lst) = (thk(lst) - tkjst)/dsqrt((v(leq)/v(lst))**2-u0**2)
        d0 = d0 + u0*vsqu(lst)
        if(lst+1 .le. leqm1) then
          do 112 l = lst+1, leqm1
            vsqu(l) = thk(l)/dsqrt( vsq(leq)/vsq(l)-u0**2)
c           vsqu(l) = thk(l)/dsqrt((v(leq)/v(l))**2-u0**2)
            d0 = d0 + u0*vsqu(l)
  112     continue
        endif
c set the distance accuracy of iteration.
        dlimit = .04d0
        if (u0 .lt. .05d0 ) goto 113
        dlimit = .015d0*v(leq)/u0
c test to see if new ray is within required distance accuracy.
  113   xtest = dabs(delta-d0)
        if (xtest  .lt.  dlimit) then
cd        print *, 'trvcon converged direct ray in ', ll, ' iterations'
          goto 220
        endif
c prepare to iterate again
c replace (u1, d1) or (u2, d2) by the new point (u0, d0)
        if (delta .lt. d2) goto 114
        d1 = d2
        u1 = u2
        d2 = d0
        u2 = u0
        goto 150
  114   if (delta .gt. d1) goto 116
        d2 = d1
        u2 = u1
        d1 = d0
        u1 = u0
        goto 150
  116   if (delta .lt. d0) goto 118
        d1 = d0
        u1 = u0
        goto 150
  118   d2 = d0
        u2 = u0
  150 continue
c if solution of direct wave does not converge in 25 iterations
      uu = asin(u0)*deg
      if (uu .lt. 0.0) uu = uu + 180.
      uu = 180. - uu
      write(punt, 172) msta, delta, z, uu, xtest, dlimit
  172 format(' travel-time solution for a direct wave from station ',
     *  a5, ' at distance ', f6.2, ' from depth ', f6.2,
     *  / ' emerging at an angle of ', f10.4,
     *  ' iterated to the limit.', /,
     *  ' came within ', f10.4, ' km.  xlimit = ', f10.4/)
c travel time & derivatives for direct wave below first layer.
  220 continue
      tdir = tkj*vi(leq)/ssqu
      do 240 l = lst, leqm1
        tdir = tdir + v(leq)*vsqu(l)/vsq(l)
240   continue
cd    print *, 'compare tdir and tmin ', tdir, tmin
      if (tdir .ge. tmin) goto 42
c     if refracted wave is faster than direct wave goto 42
c direct wave is faster
cd    print *, 'direct wave is faster than refracted'
      t = tdir
cd    print *, 'umax, u0 ', umax, u0
      if (umax-u0 .lt. .00001) then
cd      print *, 'umax - u0 .lt. .00001 '
cd      print *,
cd   *    'asin(umax), asin(u0) ', deg*asin(umax), asin(u0)
c       horizontal ray at lower limit
        if(flip) then
c         downgoing
          anin = v(lst)*vi(leq)
          ain = deg*asin(anin)
          dtdh = -sqrt(1. - anin**2)*vi(lst)
          dtdd = vi(leq)
        else
c         upgoing
          ain = 90.
          dtdh = 0.0
          dtdd = vi(leq)
        endif
        return
      endif
c compute partial derivative wrt distance (is independent of flip)
c     bot = 0.d0
c     top = 0.d0
c     do 250 l = lst, leqm1
c       term = (vsq(leq)*vsqu(l)**3)/(vsq(l)*thk(l)**2)
c       bot = bot + term
c       top = top + term*u0/v(leq)
c50   continue
c     dtdd1 = top/bot
c     simplify the formula to:
      dtdd = abs(u0)*vi(leq)
cd    print *, 'flip = ', flip
      if(flip) then
c       downgoing
cd	print *, 'downgoing, lst = ', lst
        anin = abs(u0*v(lst)*vi(leq))
        ain = deg*asin(anin)
        ssqu = sqrt(1.0 - anin**2)
c       dtdh1 = (v(lst)*anin*dtdd - 1.0)/(ssqu*v(lst))
c       simplify the formula to:
        dtdh = -sqrt(1. - anin**2)*vi(lst)
c	print *, 'dtdh fancy, plain = ', dtdh1, dtdh
      else
c       upgoing
cd	print *, 'upgoing, leq = ', leq
        anin = abs(u0)
        ain = 180. - deg*asin(anin)
c       dtdh1 = (1.0 - v(leq)*u0*dtdd)/(ssqu*v(leq))
c       simplify the formula to:
        dtdh = sqrt(1. - anin**2)*vi(leq)
c	print *, 'dtdh fancy, plain = ', dtdh1, dtdh
      endif
      return
      end
c end trvcon
c trvdrv.for    []
      subroutine trvdrv()
c---- compute travel time and derivatives from crustal model
      save
      include 'params.inc'
      parameter (ndly = 11)
      parameter (pi = 3.14159265)
      parameter (rad = pi/180.)
      logical tttset, notified
      character*4 iahead*60, msta*5, nsta*5, icard*110
      integer punt
      common /punt/ punt
      common /char1/ iahead, msta(npa), nsta(nsn), icard
      common /dit/ tid(lmax,lmmax),did(lmax,lmmax),lowv,modin(mmax+3)
      common /dmost/ ipun,ivlr,blank
      common /gmost/ az(npa)
      common /imost/ test(100)
      common /imost1/ dly(ndly,nsn),iprn,kno,klas(5, nsn)
      common /idt/ v(lmax2)
      common /ilt/ vthk(2,nsn),ipdly(nsn),mod(nsn),ipthk(nsn)
      common /ilpu/ sw(nsn),ndate(nsn),nhr(nsn),mno(nsn),ielv(nsn)
      common /iot/ flt(2,nsn),thks(nsn)
      common /ilotv/ elvdly(npa)
      common /int/ thk(lmax+1),lbeg(mmax),lend(mmax),vi(lmax),vsq(lmax),
     *  vsqd(lmmax,lmax),f(lmax,lmmax),kl,ivway,sthk(mmax),sthk1(mmax),
     *  sdly(ndly,nsn)
      common /it/ vpvs(lmax2),vpvsm(mmax+3),nttab
      common /logfil/ logfil
      common /pmost/ nr,nrp,lbastm,tp(npa),ksmp(npa),kdx(npa)
      common /pnoqtx/ ldx(npa)
      common /pot/ ts(npa),ihr,model(npa), keyphi(npa)
      common /pqt/near
      common /pt/ nlay(npa)
      common /qmost/ wt(npa),z
      real latep, lonep
      common /qmost1/ lonep,ni,latep
      common /qgo/ org
      common /qgnotx/ delta(npa)
      common /tmost/ x(4,npa)
      common /obcfn/ ain(npa)
      common /tonxb/ t(npa),fms(npa)
      common /lvz/ jref(lmax)
      data notified/.false./
      imod = 0
      nearsta = kdx(near)
      call usedly(nearsta, zuse, modset, latep, lonep)
      tttset = .false.
      zpre = -1.e22
      do 30 idum = 1,nrp
      i = idum
      elvdly(i) = 0.0
      ista = kdx(i)
      if(modset .ne. 0) then
        imod = modset
      else
        imod = mod(ista)
      endif
cds      if((delta(i) .gt. test(51)) .and. (nttab .ne. 0)) imod = 11
      if((delta(i) .gt. test(51)) .and. (nttab .ne. 0)) imod = mmax + 1
cds   write(punt, *) 'delta=', delta(i), ' test(51)=', test(51),
cds  * ' nttab=', nttab
      model(i) = imod
      ismod = 0
cds      if (imod .gt. 10) then
cds   write(punt, *) 'trvdrv mmax=', mmax, ' imod=', imod
      if (imod .gt. mmax) then
c       first deal with the p phase **********************************
        if(.not. tttset) then
c         initialize all travel time tables for current depth
          tttset = .true.
          if(z .eq. zpre) go to 14
          zpre = z
          if(z .ge. 0.) then
	    call hyset(nttab, z)
	  else
	    call hyset(nttab, 0.0)
	  endif

          if((test(8) .ne. 0.0) .and. (.not. notified)) then
	    notified = .true.
            write(punt, 10)
            write(logfil, 10)
10          format('Warning:  the elevation of the top of the velocity',
     *        ' models (test(8)) ', /,
     *        'is not zero.  ',
     *        'This is OK for travel times to distant stations.')
          endif

        endif
c                  modin = 1,2, or 3
14	continue
cds	  write(punt, *) 'near statement 14'
cds          write(punt, *) 'calling hytab.  imod=', imod,
cds  *      ' modin(imod)=', modin(imod)
        call hytab(modin(imod), delta(i), t(i), ain(i), dtdd,
     *               dtdh, vt, vs)
        ista = kdx(i)
c       set elevation delay for p phase
        elvdly(i) = 0.0
        if (test(2) .ge. 0.0) then
          if (test(2) .gt. 0.0) then
            tes2 = test(2)
          else
            tes2 = vt
          endif
          utop = (sin(rad*ain(i))*tes2/vs)**2.0
          if(utop .gt. 1.) then
            write(punt, 20) ista,utop,i,ain(i),tes2,vs
            elvdly(i) = 0.0
          else
            elvdly(i) = (ielv(ista)/1000.)*(sqrt(1.0001-utop))/tes2
          endif
        endif
c       p phase derivatives
        x(1,i) = +dtdd*sin(az(i)*rad)
        x(2,i) = -dtdd*cos(az(i)*rad)
        x(3,i) = dtdh
        x(4,i) = tp(i) - t(i) - org - dly(kno,ista) - elvdly(i)
c       now for the s phase ******************************************
        if (ldx(i) .eq. 0) goto 30
        k = ldx(i)
        vpvsmk = vpvsm(imod)
        if (vpvsmk .lt. 0.0) then
c         use travel time table modin(imod) + 1 for the s phase
          model(k) = imod + 1
cds       write(punt, *) "calling hytab.  k=", k, ' imod=', imod,
cds  *      ' modin(imod)=', modin(imod)
          call hytab(modin(imod) + 1, delta(i), t(k),
     *               ain(k), dtdd, dtdh, vts, vss)
          x(1,k) = +dtdd*sin(az(i)*rad)
          x(2,k) = -dtdd*cos(az(i)*rad)
          x(3,k) = dtdh
          vpvsmk = vt/vts
        else
c         assume a constant vp/vs ratio for the s phase parameters
          t(k) = t(i)*vpvsmk
          model(k) = model(i)
          x(1,k) = x(1,i)*vpvsmk
          x(2,k) = x(2,i)*vpvsmk
          x(3,k) = x(3,i)*vpvsmk
          ain(k) = ain(i)
          vts = vt/vpvsmk
          vss = vs/vpvsmk
        endif
c       set elevation delay for s phase
        elvdly(k) = 0.0
        if (test(2) .ge. 0.0) then
          if (test(2) .gt. 0.0) then
            tes2 = test(2)/vpvsmk
          else
            tes2 = vts
          endif
          utop = (sin(rad*ain(k))*tes2/vss)**2.0
          if(utop .gt. 1.) then
            write(punt, 20) ista,utop,k,ain(k),tes2,vss
            elvdly(k) = 0.0
          else
            elvdly(k) = (ielv(ista)/1000.)*(sqrt(1.0001-utop))/tes2
          endif
        endif
        x(4,k) = tp(k) - t(k) - org - sdly(kno,ista) - elvdly(k)
        goto 30
      endif
c**********************************************************************
c     layer model calculations begin here *****************************
      vpvsk = vpvsm(imod)
      if(vpvsk .eq. 0.) vpvsk = test(1)
c     test(8) is the elevation in km of the top of the model
      stz = test(8) - ielv(ista)*.001
      if(stz .lt. 0.0) stz = 0.0
15    nlayers = lend(imod) - lbeg(imod) + 1
c     write(punt, *) 'trvdrv, imod = ', imod, ' lend(imod) = ',
c    *  lend(imod), ' v = ', v(lend(imod))
      if(v(lend(imod)) .lt. 100.) then
c----
c----   constant velocity within each layer with topography
c     variables associated with the variable layer thickness option
c     ivl              layer with variable thickness (=0 to skip this option)
c     vthk(1/2, ista)  model 1/2 thickness assigned to station ista (each
c                        station is assigned two thicknesses)
c     ipthk(ista)      preferred thickness model of station ista
c     lowv             1/0  do/don't make compensating change in thichkess
c                        of layer below the variable layer
c     ivway            neg/0/pos  source/average/receiver station variable
c                        thickness is used
        ivl = lbeg(imod) + ivlr - 1
        if(ivlr .gt. 0) then
c----     determine thickness of the variable layer.
c----     ivway :::  negative-source, positive-receiver, zer0-average
          if(ivway .lt. 0) then
            thk(ivl) = vthk(ipthk(nearsta), ista)
          else if(ivway .gt. 0) then
            thk(ivl) = vthk(ipthk(ista), ista)
          else
            thk(ivl) =
     *        (vthk(ipthk(nearsta),nearsta) +
     *        vthk(ipthk(nearsta),ista))*0.5
            sum = 0.0
            do 16 l = lbeg(imod),ivl
              sum = sum+thk(l)
16          continue
            if (z .ge. sum) then
              thk(ivl) = vthk(ipthk(nearsta),ista)
            endif
          endif
          thk(ivl + 1) = sthk1(imod) - lowv*(thk(ivl) - sthk(imod))
          if(thk(ivl+1) .le. 0.0) thk(ivl+1) = 0.01
          thks(i) = thk(ivl)
        endif
        k = ldx(i)
        if (k .ne. 0) wtk = wt(k)
        call trvcon( delta(i), z, t(i), ain(i), dtdd, dtdh,
     *            lbeg(imod), lend(imod), lbeg(imod)-1, nlayers,
     *            ivlr, ivl, thk, nlay(i), ldx(i), wt(i), wtk,
     *            tid, did, jref, vsq, vsqd, v, vi, f,
     *            vs, vt, msta(i), stz)
        if (k .ne. 0) wt(k) = wtk
      else if(v(lend(imod)) .eq. 100.) then
c----
c----   linear increase, no half space
        write(punt, 17)
        write(logfil, 17)
17      format(' a linear increase with no half space is ',
     *   ' no longer allowed, so stop')
        stop 'abort from trvdrv'
      else if(v(lend(imod)) .eq. 200.) then
c----
c----   linear increase over half space with topography
        vzero = v(lbeg(imod))
        grad  = v(lbeg(imod) + 1)
        zhalf = v(lbeg(imod) + 2)
        vhalf = v(lbeg(imod) + 3)
c       linvol incorporates station elevations
c       print *, '1: i, delta(i), z, stz ', i, delta(i), z, stz
        call linvol(delta(i), z, stz, grad, vzero, zhalf,
     *    vhalf, t(i), ain(i), dtdd, dtdh)
        vt = vzero + stz*z
        vs = vzero + grad*z
        if(z .gt. zhalf) vs = vhalf
      else if(v(lend(imod)) .eq. 300.) then
c----
c----   linear increase with topography
        vzero = v(lbeg(imod))
        grad  = v(lbeg(imod) + 1)
        call linv(delta(i),   z, vzero, grad,
     *    t(i), ain(i), dtdd, dtdh, stz, vt, vs)
cd    else if(v(lend(imod)) .eq. 400.) then
c----
c----   lienert velocity routine with embedded stations allowed
c     dimension parm(lmax2)
c   inputs:    delta  distance from eq to station in km
c              stz    depth of station in km below top of model
c              eqz    depth of eq in km below top of model
c              nn     number of parameters ( = 2*nl - 1)
c              parm(i), i = 1, nl   layer velocities
c              parm(i), i = nl + 1, nn  layer thicknesses
c   outputs:
c              tmin   minimum travel time
c              dtdd   partial derivative of tt wrt distance (s/km)
c              dtdh   partial derivative of tt wrt depth (s/km)
c              ian    angle of incidence in degrees
c       the last layer is excluded, so
cd      nlayers = lend(imod) - lbeg(imod)
cd      do 18 itmp = 1, nlayers
cd        parm(itmp) = v(lbeg(imod) + itmp - 1)
cd        if(itmp .lt. nlayers)
cd   *      parm(itmp+nlayers) = thk(lbeg(imod) + itmp - 1)
cd18    continue
cd      call dtdx2(2*nlayers-1, parm, delta(i), z , stz, t(i),
cd   *  dtdd, dtdh, ain(i), vt, vs)
      else
        write(punt, 19) imod, v(lend(imod))
        write(logfil, 19) imod, v(lend(imod))
19      format(' halfspace velocity for model ', i2, ' may not equal ',
     *    f10.2, /, 'so stop!')
        stop 'abort from trvdrv'
      endif
c----
      elvdly(i) = 0.0
c     if test(8) is non zero, then elevations are accounted for by
c       the location of the stations within the model.
      if ((test(2) .ge. 0.0) .and. (test(8) .eq. 0.0)) then
        if(test(2) .gt. 0.0) then
c----     elevation correction using test(2) as surface velocity
          if(ismod .eq. 1) then
            tes2 = tes2/vpvsk
          else
            tes2 = test(2)
          endif
        else
c----     elevation correction using 1'st layer velocity as surface velocity
          tes2 = vt
        endif
        utop = (sin(rad*ain(i))*tes2/vs)**2.
        if(utop .gt. 1.) then
          write(punt, 20) ista,utop,i,ain(i),tes2,vs
20        format(' sub trvdrv: velocity for elev correction',
     *      ' should not be greater than velocity at source.', /,
     *      ' for ista =',i5,' utop =',f12.7,' ain(',i5,') =',f12.7,
     *     /' v for elev cor =',f12.7,' and v at source =',f12.7)
          elvdly(i) = 0.
        else
          elvdly(i) = (ielv(ista)/1000.)*(sqrt(1.0001-utop))/tes2
        endif
      endif
c---- calculate the partial derivatives of t wrt lon, lat, & z
c----    and find the residuals.
c----
c---- p phase derivatives
      x(1,i) = +dtdd*sin(az(i)*rad)
      x(2,i) = -dtdd*cos(az(i)*rad)
      x(3,i) = dtdh
      if(ismod .eq. 0) go to 27
c---- s phase model just used
      x(4,i) = tp(i) - t(i) - org - sdly(kno,ista) - elvdly(i)
      go to 30
27    if(ksmp(i) .eq. 0) go to 29
c---- p phase residuals
      x(4,i) = tp(i) - t(i) - org - dly(kno,ista) - elvdly(i)
      if(ldx(i).eq.0) go to 30
c---- check for s model
      if(vpvsm(imod) .eq. 0.0) then
        ismod = 1
        i = ldx(i)
        imod = imod + 1
        model(i) = imod
        go to 15
      endif
c---- s phase data -- based on constant vpvs
      k = ldx(i)
      model(k) = imod
      elvdly(k) = elvdly(i)*vpvsk
      t(k) = t(i)*vpvsk
      x(1,k) = x(1,i)*vpvsk
      x(2,k) = x(2,i)*vpvsk
      x(3,k) = x(3,i)*vpvsk
      x(4,k) = tp(k) - t(k) - org - sdly(kno,ista) - elvdly(k)
      ain(k) = ain(i)
      go to 30
c---- s minus p data
29    x(1,i) = x(1,i)*(vpvsk-1.)
      x(2,i) = x(2,i)*(vpvsk-1.)
      x(3,i) = x(3,i)*(vpvsk-1.)
      x(4,i) = ts(i)-tp(i)-(vpvsk-1.)*(t(i)+elvdly(i))
     *  + dly(kno,ista) - sdly(kno,ista)
30    continue
      return
      end
c end trvdrv
c tshift.for    []
      subroutine tshift(kdate,khr,kmin,sec,ssec)
c resolve unreasonable times
    5 if (sec .lt. 60.0) goto 20
      sec = sec - 60.0
      ssec = ssec - 60.0
      kmin = kmin + 1
      goto 5
   20 if (sec .ge. 0.0) goto 40
      sec = sec + 60.0
      ssec = ssec + 60.0
      kmin = kmin - 1
      goto 20
   40 if (kmin .lt. 60) goto 60
      kmin = kmin - 60
      khr = khr + 1
      goto 40
   60 if (kmin .ge. 0) goto 80
      kmin = kmin + 60
      khr = khr - 1
      goto 60
   80 if (khr .lt. 25) goto 100
      khr = khr - 24
      kdate = kdate + 1
      goto 80
  100 if (khr .ge. 0) goto 120
      khr = khr + 24
      kdate = kdate - 1
      goto 100
  120 return
      end
c end tshift
c uamag.for    [pc]
      subroutine uamag (icent2, msta, source, date, dstsqr,
     &  amplit, period, magnit, clusei, sysmag, gndmot,
     & wa_static_mag, punt, blank)
c originally written by steve a. estes long, long ago.
c file fields: msta, start date, stop date, mag for
c   periods .6, .5, .4, .3, .2, .1
c updated 10/22/81 by sae to increase deminsion of
c   f, lsta, date1, date2 to 500.
c updated 12/09/82 by ghcs to be compatible with hypoe82.
c updated 03/23/88 by jcl to incorporate into hypoellipse.
c   stations with system response code = 18 will use this
c   subroutine for xmag calc.
c re-written 09/21/88 by ghcs:  generalized the calibration data to
c   include an arbitrary number of period, magnification pairs for
c   each station entry.  the program was also restructured in fortran
c   77 and separate routines were created:  get_uacaldata() for input
c   and log_interp() for interpolation.
c once more 5/17/89 by jcl.
c   modified to be compatible with vax/vms fortran, which can not read
c   a free format character variable unless the variable is enclosed
c   in quotes.  format must now be a3 or a4 station name followed by
c   one space and then the a1 source code.
c   removed implicit undefined statements.
c   make all source comparisons in upper case.
c   corrected loga0_tbl(2,2) from 50 to 35
c updated 10/20/89 by ghcs to use unformatted data file via the
c   get_bin_uacaldata() routine.
c 6/6/91 by jcl
c   extended loga0_tbl down to 0.1 km distance, to make this routine
c   compatible with xfmags, and so that magnitudes can be computed at
c   close distances.
c 12/23/91 by jcl
c   msta and amp_source are lower case, so use dnstrn in comparison
c 7/15/95 correct interpolation period in wood_anderson table
c 10/22/95 eliminate wood_anderson interpolation and use function wa_magn
c 5/30/97 extented loga0_tbl to 1500 km distance.  jcl
c 2/24/99 add icent2 to keep track of century.  jcl

      save station_list, amp_source, nrecords, npoints,
     &     begin_date, end_date, period_sysmag,
     &     loga0_tbl
      integer max_records, max_stacode, max_points, max_wapoints
      integer max_loga0pts
      integer punt
c* (vax
c* (unix
c      parameter (max_records = 1000)
c* unix)
c* vax)
c* (pc
      parameter (max_records = 100)
c* pc)
      parameter (max_stacode = 4)
      parameter (max_points = 30)
      parameter (max_wapoints = 4)
      parameter (max_loga0pts = 4)
      integer data_unit
      parameter (data_unit = 24)
c --- declare the subroutine arguments:
      character msta*(5)
      integer date
      real dstsqr, amplit, period, magnit, clusei
c --- declare the common variables:
      character*50 uacal
      common /dix/ iexcal, uacal
c --- declare the local variables:
      character*4 dnstrg
      character station_list(max_records)*(max_stacode)
      character amp_source(max_records)*1, source*1
      integer i, j, k, nrecords, npoints(max_records)
      integer begin_date(max_records), end_date(max_records)
      integer beg_cent, end_cent
      real period_sysmag(2,max_points,max_records)
c     real wood_anderson(2,max_wapoints)
      real loga0_tbl(2,max_loga0pts)
c     real zmc1, zmc2, pwc1, pwc2
      real loga, loga0, sysmag, wa_mag, km, slope, delta, x1, x2
c --- log-log interpolation function.
      real log_interp	
c --- are the periods here given in backwards order???
c     data wood_anderson/.1, 2787.5, .2, 2747.1, .3, 2671.5,
c    &                   .4, 2553.4, .5, 2391.0, .6, 2192.2/
c correct 3rd period 7/15/95 from .8 to .6
c    &                    .8, 2192.2, 42.4, 1.0/
c compute wood anderson magnification rather than extrapolate
c starting 10/22/95
c     data wood_anderson /.01, 2800., .1, 2787.5,
c    &                    .6, 2192.2, 42.4, 1.0/
c     data loga0_tbl /10.,1.5, 50.,2.3, 200.,3.5, 600.,4.9/
c     data loga0_tbl /10.,1.5, 35.,2.3, 200.,3.5, 600.,4.9/
c     data loga0_tbl /0.1,-1.75, 35.,2.3, 200.,3.5, 600.,4.9/
      data loga0_tbl /0.1,-1.75, 35.,2.3, 200.,3.5, 1500.,6.15/
c     data zmc1/0.15/, zmc2/3.38/, pwc1/0.80/, pwc2/1.50/
      data nrecords/-1/
c     write (punt,*)
c    & 'msta, source, date, dstsqr, amplit, period, magnit, clusei'
c     write (punt,*) msta, source, date, dstsqr,
c    &                    amplit, period, magnit, clusei
c a source of '%' is presumed to be the same as 'a'
      sysmag = blank
      gndmot = blank
      if (source .eq. '%') source = 'a'
c **********************************************
c *** correction for magnification different ***
c *** from 2800.                             ***
c     amag_cor = wamag/2800.
c ***                                        ***
c **********************************************
c *** the first time the routine is called, ***
c *** read in the initial calibration data. ***
c *** units of sysmag are "units"/mm.       ***
c *** currently (1991) units are counts/mm  ***
c *********************************************
      if (nrecords.eq.-1)  then
cd        print *, 'about to open ', uacal
cd        print *, 'for unformatted read on unit ', data_unit
c* (unix
c        call openfl(data_unit, uacal, 'old', 'null', 'none',
c     *    'unformatted', 0)
c        print *, 'about to call getbin to read unit ', data_unit
c        call getbin (data_unit,
c     &  max_records, max_points, nrecords, station_list, amp_source,
c     &  begin_date, end_date, npoints, period_sysmag)
c* unix)
c* (vax
c* (pc
        call get_uacaldata (uacal, max_records,
     &  max_points, nrecords, station_list, amp_source, begin_date,
     &  end_date, npoints, period_sysmag, data_unit, punt)
c* pc)
c* vax)
        print *, 'just read ', nrecords, ' records'
        close (data_unit)
      endif
c ***********************************************
c *** convert the distance squared into km.   ***
c *** also, we only want to calculate a mag   ***
c *** for dstsqrs defined in the loga0_tbl    ***
c *** & periods defined in the wood anderson  ***
c *** table.                                  ***
c ***********************************************
      km = sqrt(dstsqr)
c     if (km.lt.loga0_tbl(1,1) .or.
c    &    km.gt.loga0_tbl(1,max_loga0pts)) then
c       clusei = -1
c       return
c     end if
c     if (period.lt.wood_anderson(1,1) .or.
c    &    period.gt.wood_anderson(1,max_wapoints) ) then
      if (period .le. 0.0) then
        clusei = -1
        return
      end if
c *******************************************************
c *** find this station's current calibration record. ***
c *** this should be done much more efficiently!      ***
c *******************************************************
      do 50 k=1, nrecords
c      print *, 'station = ', dnstrg(station_list(k)), msta
c      print *, 'source = ', dnstrg(amp_source(k)), source
        if (end_date(k) .eq. 999999) end_date(k) = 699999
        if ((dnstrg(station_list(k)) .eq. msta(1:4)) .and.
     &      (dnstrg(amp_source(k))   .eq. source)) then
c if the year is less than 70, then this must be after 1999
	  if (begin_date(k)/10000 .lt. 70) then
	     beg_cent = 20
	  else
	     beg_cent = 19
	  endif
	  if (end_date(k)/10000 .lt. 70) then
	     end_cent = 20
	  else
	     end_cent = 19
	  endif
          if (  (
     *            ((beg_cent .eq. icent2) .and.
     *	           (begin_date(k) .le. date)) .or.
     *	          (beg_cent .lt. icent2)
     *          )
     *          .and.
     *          (
     *            ((end_cent .eq. icent2) .and.
     *             (end_date(k) .ge. date)) .or.
     *            (end_cent .gt. icent2)
     *          )
     *       ) goto 100
        endif
50    continue
c --- no calibration data matches
      write (punt,'('' no calibration data for /'',a4,''/ source='',a1,
     &  '' date='',i2.2,i6.6)') msta(1:4), source, icent2, date
      clusei = -1.0
      return	
c ***********************************************************
c *** find the system magnification for the given period. ***
c ***********************************************************
100   if (period.lt.period_sysmag(1,1,k) .or.
     &    period.gt.period_sysmag(1,npoints(k),k) ) then
        write (punt,
     &    '('' no calibration data for /'',a4,''/ source='',a1,
     &    '' date='',i6.6,i2,'' at period='',f5.2)')
     &    msta(1:4), source, date, icent2, period
        clusei = -1
        return
      end if
      do 120 i=1, npoints(k)-1
        j = i + 1
        if (period.eq.period_sysmag(1,i,k)) then
c         we have an exact period match, so don't interpolate
          sysmag = period_sysmag(2,i,k)
          goto 200
        else if (period.eq.period_sysmag(1,j,k)) then
c         we have an exact period match, so don't interpolate
          sysmag = period_sysmag(2,j,k)
          goto 200
        else if (period.gt.period_sysmag(1,i,k) .and.
     &           period.lt.period_sysmag(1,j,k)) then
c         we have a period within our defined range, so interpolate.
          sysmag = log_interp (period,
     &               period_sysmag(1,i,k), period_sysmag(2,i,k),
     &               period_sysmag(1,j,k), period_sysmag(2,j,k))
          if (sysmag.lt.0.0) then
            write (punt,'('' sysmag.lt.0 for '',a4)') msta(1:4)
            clusei = -1.0
            return
          endif
          goto 200
        end if
120   continue
c --- we should never be able to get here.
      clusei = -1
      return
c *************************************************************
c *** find the wood anderson response for the given period. ***
c *************************************************************
200   wa_mag = wa_magn(wa_static_mag, period)
c ***************************************
c *** bail out if sysmag is too small ***
c ***************************************
      if (sysmag.lt.0.00001) then
        write (punt,'('' sysmag.lt.0.00001 for '',a4)') msta(1:4)
   	sysmag = blank
        clusei = -1.0
        return
      endif
c *************************
c * compute ground motion *
c *************************
      gndmot = (amplit*10**3)/sysmag
c **********************************
c * find the correct distance term *
c **********************************
      do 320 i=1, max_loga0pts-1
        j = i + 1
        if (km.eq.loga0_tbl(1,i)) then
          loga0 = loga0_tbl(2,i)
          goto 400
        else if (km.eq.loga0_tbl(1,j)) then
          loga0 = loga0_tbl(2,j)
          goto 400
        else if (km.gt.loga0_tbl(1,i) .and. km.lt.loga0_tbl(1,j)) then
c ---     interpolate
          x1 = log10(loga0_tbl(1,i))
          x2 = log10(loga0_tbl(1,j))
          delta = x2 - x1
          if (abs(delta) .le. 0.0000001) then
            loga0 = loga0_tbl(2,i)
          else
            slope = (loga0_tbl(2,j) - loga0_tbl(2,i)) / delta
            loga0 = slope * (log10(km) - x1) + loga0_tbl(2,i)
          endif
          goto 400
        end if
320   continue
c --- we shouldn't be able to get here since
c --- outlaying distances were trapped above.
      clusei = -1
      return
c *****************************
c *** compute the magnitude ***
c *****************************
400   loga = log10( amplit * wa_mag / (2. * sysmag) )
c     loga0 = zmc1 - pwc1 * log10(km)
c     if (km.ge.40.) loga0 = zmc2 - pwc2 * log10(km)
      magnit = loga + loga0
c     write (punt,*) ' amp=',amplit,' period=',period,
c    &  ' dist_km=',km,' sysmag=',sysmag,' wa_mag=',wa_mag,
c    &  ' loga=',loga,' loga0=',loga0,' mag=',magnit
      clusei = sysmag / 1000000.
c *****************************************************
c *** exclude magnitude if distance is out of range ***
c *****************************************************
      if (km.lt.loga0_tbl(1,1) .or.
     &    km.gt.loga0_tbl(1,max_loga0pts)) then
        clusei = -1
      end if
      return
      end
c *************************************************************
c *************************************************************
c* (vax
c* (pc
      subroutine get_uacaldata (filename, max_records, max_points,
     &             nrecords, station_list, amp_source, begin_date,
     &             end_date, npoints, period_sysmag, data_unit,punt)
c           - subroutine get_uacaldata is not used on unix systems.
c             however, please leave code here so that switch to vax
c             can be made.
c* pc)
c* vax)
c* (pc
cds$notruncate
c* pc)
c* (vax
c* (pc
c --- input for this routine is a free formatted ascii file of
c --- station calibration data.  it is a sequence of up to
c --- <max_records> (logical) records (which may span several
c --- physical records) ordered in the following manner:
c --- 'sta_code', 'source', begin_yymmdd, end_yymmdd, npairs,
c --- period(1), sysmag(1), period(2), sysmag(2), ...
c --- period(npairs), sysmag(npairs)
c --- note: the period, magnification pairs must be in order of
c --- increasing period (i.e. this is reversed from the old routine).
      character*300 calrec
      character rshft*4, dnstrg*4
      integer max_records, max_points, nrecords
      character filename*(*), station_list(max_records)*(*)
      character amp_source(max_records)*1
      integer  begin_date(*), end_date(*), npoints(*), data_unit
      real period_sysmag(2,max_points,max_records)
      integer i, punt
      call openfl(data_unit, filename, 'old', 'null', 'none',
     *    'none', 0)
      nrecords = 0
100   if (nrecords.lt.max_records) then
        nrecords = nrecords + 1
        read (data_unit, '(a)', end=116) calrec
c because standard fortran 77 to can not read an internal file with
c free format, file 14 must be used in the following code!
        rewind 14
        write(14, '(a)') calrec
        station_list(nrecords) = calrec(1:4)
        rewind 14
        if(calrec(4:4) .eq. ' ') then
          amp_source(nrecords) = dnstrg(calrec(5:5))
          write(14, '(a)') calrec(6:lentru(calrec))
        else
          amp_source(nrecords) = dnstrg(calrec(6:6))
          write(14, '(a)') calrec(7:lentru(calrec))
        endif
        rewind 14
        read (14, *, err=118)
     &    begin_date(nrecords), end_date(nrecords), npoints(nrecords),
     &    (period_sysmag(1,i,nrecords), period_sysmag(2,i,nrecords),
     &    i=1, npoints(nrecords))
c ---   this doesn't solve the overflow problem, but it might help.
        if (npoints(nrecords).gt.max_points) then
          npoints(nrecords) = max_points
          write (*, '('' warning: too many data points on record #'',
     &      i6, '' of uofa calibration file:'', /, a)')
     &      nrecords, filename
        endif
c ---   right justify the 3-character station codes and shift to uppercase.
        station_list(nrecords) = dnstrg(rshft(station_list(nrecords)))
c ---   read next record
        goto 100			
116     continue
          nrecords = nrecords - 1	
          return
118     continue
          write (punt, 120) nrecords, filename
120       format(' warning: error reading record #', i5,
     &           ' from uofa calibration file:', /, 1x, a, /,
     &           ' remainder of file skipped.')
          return
      else
        write (punt, 130) max_records, filename
130     format(' warning: too many records (>',i5,
     &    ') in uofa calibration file:', /, 1x, a)
      endif
      return
      end
c* pc)
c* vax)
cc *************************************************************
      real function log_interp (x, x1, y1, x2, y2)
c* (pc
cds$notruncate
c* pc)
c --- returns the y cooresponding to a linear interpolation
c --- between x1, y1 and x2, y2 in the log-log plane.
c --- note that -1.0 is returned if any of the arguments are
c --- not positive. y1 is returned if the difference in the
c --- logs of x1 and x2 is too near zero.
      real x, x1, x2, y1, y2
      real log_x, log_x1, log_x2, log_y1, log_y2
      real delta, slope
      if ((x.le.0.0) .or.
     &    (x1.le.0.0) .or. (x2.le.0.0) .or.
     &    (y1.le.0.0) .or. (y2.le.0.0) ) then
c       write (punt,*) ' error', x, x1, y1, x2, y2
c ---   error, return error status
        log_interp = -1.0	
      else
        log_x = log10(x)
        log_x1 = log10(x1)
        log_x2 = log10(x2)
        log_y1 = log10(y1)
        log_y2 = log10(y2)
        delta = log_x2 - log_x1
        if (abs(delta) .le. 0.0000001) then
c ---     avoid dividing by zero
          log_interp = y1	
        else
          slope = (log_y2 - log_y1) / delta
          log_interp = 10.0 ** (slope * (log_x - log_x1) + log_y1)
        endif
      endif
      return
      end
c end uamag
c unfold2.for    []
      subroutine unfold2(alat,alon,la,ins,ala,lo,iew,alo)
c     unfold2
c
c-------- given geocentric lat and lon compute geographic coordinates
c            suitable  for printing
c
c input and output definition just reverse of entry fold2
c
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
      parameter (c1 = (1.0 - flat)**2)
      parameter (c2 = halfpi*(1.0/c1 - 1.0))
c
      character*1 ins, iew
c
c
c convert from geocentric lat and lon to geographic
c
c     alat     geocentric lat (radians)
c     alon                lon (radians)
c     la,ins,ala          lat in deg and min
c     lo,iew,alo          lon in deg and min
c
c gctogg - convert from geocentric to geographic latitude
      if (halfpi-abs(alat) .ge. 0.02) goto 403
         blat = c1*(alat + sign(c2,alat))
         goto 404
  403    blat = atan(tan(alat)/c1)
  404 continue
      ins = 'n'
      iew = 'w'
      ala1 = blat*deg
      la = ala1
      ala = abs(ala1 - la)*60.
      la = iabs(la)
      if (ala1 .lt. 0.0) ins = 's'
      alo1 = alon*deg
      lo = alo1
      alo = abs(alo1 - lo)*60.
      lo = iabs(lo)
      if (alo1 .lt. 0.0) iew = 'e'
      return
      end
c end unfold2
